//---------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop
#include <Clipbrd.hpp> //prce se chrnkou
#include <sstream>
#include <cmath.h>
#include "About.h"   //dialog o programu
#include "Main.h"    //tlo programu
#include "Strs.h"  //definice chybovch hlen
#include "MAPI.hpp"
#include "rsc_geo.h"   //GEO funkce
#include "rsc_math.h"  //MAT funkce
#include "rsc_mapove_listy.h"   //funkce pro prci s mapovmi listy
#include "cr.h"     //mapa R
#include "svet.h"   //mapa svta

//---------------------------------------------------------------------------
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------

__fastcall TForm1::TForm1(TComponent *Owner)
	: TForm(Owner)
{
	FFileName = LoadStr(sUntitled); //vytvoen przdnho
	RichEdit1->Lines->Clear();      //dokumentu po sputn
	RichEdit1->Modified = false;    //programu

        //poten nastaven
        RadioButton1->Checked = true;    //zan se souadnicemi v JTSK
        Label1->Caption = "Y";
        Label2->Caption = "X";

        EditY->Visible = true;
        EditX->Visible = true;

        Edit2->Visible = false;
        Edit3->Visible = false;
        Edit4->Visible = false;
        Edit5->Visible = false;
        Edit6->Visible = false;
        Edit7->Visible = false;
        GroupBox2->Visible = false;
        GroupBox3->Visible = false;
        CheckBox1->Visible = false;


          //zadn peddefinovanch hodnot
//        EditY->Text = 762158.258;   //Y
//        EditX->Text = 1040269.851;   //X

//3852'10" S  776'32" Z   Pentagon :)
 /*       RadioButton2->Checked = true;  //zempisn
        Edit2->Text = 38;   //ka
        Edit3->Text = 52;
        Edit4->Text = 10;
        RadioButtonS->Checked = true;  //sever
        RadioButtonJ->Checked = false;  //jih

        Edit5->Text = 77;   //dlka
        Edit6->Text = 6;
        Edit7->Text = 32;
        RadioButtonV->Checked = false;  //vchod
        RadioButtonZ->Checked = true;  //zpad
        CheckBox1->Checked = false;  //false = Greenwitch, true = Ferro
*/

//     ToolButton11Click(this); //vpoet z peddefinovanch hodnot

}
//---------------------------------------------------------------------------

void __fastcall TForm1::FileNew1Execute(TObject *Sender)
{
if(RichEdit1->Modified == true) {
  TMsgDlgButtons temp_set;
  temp_set<< mbYes<<mbNo <<mbCancel;
  String buffer = "Uloit zmny v souboru '" + FFileName + "'?";
  switch(MessageDlg(buffer, mtCustom,temp_set,0)) {

    case mrYes:
      FileSave1Execute(this);
      FFileName = LoadStr(sUntitled);
	RichEdit1->Lines->Clear();
	RichEdit1->Modified = false;
      break;

    case mrNo:
      FFileName = LoadStr(sUntitled);
	RichEdit1->Lines->Clear();
	RichEdit1->Modified = false;
      break;

    case mrCancel:
      break;
                                                  }
     }//if
else {	FFileName = LoadStr(sUntitled);
	RichEdit1->Lines->Clear();
	RichEdit1->Modified = false;
     }


}
//---------------------------------------------------------------------------

void __fastcall TForm1::FileOpen1Execute(TObject *Sender)
{

if(RichEdit1->Modified == true) {
  TMsgDlgButtons temp_set;
  temp_set<< mbYes<<mbNo <<mbCancel;
  String buffer = "Uloit zmny v souboru '" + FFileName + "'?";
  switch(MessageDlg(buffer, mtCustom,temp_set,0)) {

    case mrYes:
      FileSave1Execute(this);
	if (OpenDialog->Execute())
	{
		RichEdit1->Lines->LoadFromFile(OpenDialog->FileName);
		FFileName = OpenDialog->FileName;
		RichEdit1->SetFocus();
		RichEdit1->Modified = false;
		RichEdit1->ReadOnly = OpenDialog->Options.Contains(ofReadOnly);
	}
      break;

    case mrNo:
	if (OpenDialog->Execute())
	{
		RichEdit1->Lines->LoadFromFile(OpenDialog->FileName);
		FFileName = OpenDialog->FileName;
		RichEdit1->SetFocus();
		RichEdit1->Modified = false;
		RichEdit1->ReadOnly = OpenDialog->Options.Contains(ofReadOnly);
	}
      break;

    case mrCancel:
      break;
                                                  }
     }//if

else{
	if (OpenDialog->Execute())
	{
		RichEdit1->Lines->LoadFromFile(OpenDialog->FileName);
		FFileName = OpenDialog->FileName;
		RichEdit1->SetFocus();
		RichEdit1->Modified = false;
		RichEdit1->ReadOnly = OpenDialog->Options.Contains(ofReadOnly);
	}
     }//else

}
//---------------------------------------------------------------------------

void __fastcall TForm1::FileSave1Execute(TObject *Sender)
{

    RichEdit1->PlainText =true; //pevede RTF na TXT

	if (FFileName == LoadStr(sUntitled))
		FileSaveAs1Execute(Sender);
	else
	{
		RichEdit1->Lines->SaveToFile(FFileName);
		RichEdit1->Modified = false;
	}
}
//---------------------------------------------------------------------------

void __fastcall TForm1::FileSaveAs1Execute(TObject *Sender)
{

    RichEdit1->PlainText =true; //pevede RTF na TXT

	String str;
	TVarRec vrs[1];

	if (SaveDialog->Execute())
	{
		if (FileExists(SaveDialog->FileName))
		{
			str = FmtLoadStr(sOverwrite, OPENARRAY(TVarRec, (SaveDialog->FileName)));
			if (MessageDlg(str, mtConfirmation, TMsgDlgButtons() << mbYes << mbNo <<
				mbCancel, 0) != IDYES)
				return;
		}
		RichEdit1->Lines->SaveToFile(SaveDialog->FileName);
		FFileName = SaveDialog->FileName;
		RichEdit1->Modified = false;
	}
}
//---------------------------------------------------------------------------

void __fastcall TForm1::FileSend1Execute(TObject *Sender)
{
	TMapiMessage MapiMessage;
	Cardinal MError;

	MapiMessage.ulReserved = 0;
	MapiMessage.lpszSubject = NULL;
	MapiMessage.lpszNoteText = RichEdit1->Lines->Text.c_str();
	MapiMessage.lpszMessageType = NULL;
	MapiMessage.lpszDateReceived = NULL;
	MapiMessage.lpszConversationID = NULL;
	MapiMessage.flFlags = 0;
	MapiMessage.lpOriginator = NULL;
	MapiMessage.nRecipCount = 0;
	MapiMessage.lpRecips = NULL;
	MapiMessage.nFileCount = 0;
	MapiMessage.lpFiles = NULL;

	MError = MapiSendMail(0, 0, MapiMessage, MAPI_DIALOG | MAPI_LOGON_UI |
		MAPI_NEW_SESSION, 0);

	if (MError)
		MessageDlg(LoadStr(sSendError), mtError, TMsgDlgButtons() << mbOK, 0);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::FileExit1Execute(TObject *Sender)
{

if(RichEdit1->Modified == true) {
  TMsgDlgButtons temp_set;
  temp_set<< mbYes<<mbNo <<mbCancel;
  String buffer = "Uloit zmny v souboru '" + FFileName + "'?";
  switch(MessageDlg(buffer, mtCustom,temp_set,0)) {

    case mrYes:
    FileSave1Execute(this);
      Close();
      break;

    case mrNo:
      Close();
      break;

    case mrCancel:
      break;
                                                  }
     }//if

else Close();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::HelpAbout1Execute(TObject *Sender)
{
	AboutBox->ShowModal();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Nastaventisku1Click(TObject *Sender)
{
PrinterSetupDialog1->Execute();        
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Tisk1Click(TObject *Sender)
{
if (PrintDialog1->Execute()){                //vytitn souboru
  try {
      RichEdit1->Print(FFileName);
      }//try
  catch(...){
//      Printer()->EndDoc();
      throw;
  }//catch

}//if
}
//---------------------------------------------------------------------------

void __fastcall TForm1::ToolButton10Click(TObject *Sender)
{
Tisk1Click(this);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::SelectAll1Click(TObject *Sender)
{
RichEdit1->SelectAll();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Del1Click(TObject *Sender)
{
RichEdit1->ClearSelection();        
}
//---------------------------------------------------------------------------

void __fastcall TForm1::WordWrap1Click(TObject *Sender)
{
RichEdit1->WordWrap = !RichEdit1->WordWrap;
if (RichEdit1->WordWrap)
  RichEdit1->ScrollBars = ssVertical;
else 
  RichEdit1->ScrollBars = ssBoth;
WordWrap1->Checked = RichEdit1->WordWrap;

}
//---------------------------------------------------------------------------

void __fastcall TForm1::Edit1Click(TObject *Sender)
{
bool HasSelection;
HasSelection = RichEdit1->SelLength > 0;
Del1->Enabled = HasSelection;
}
//---------------------------------------------------------------------------


void __fastcall TForm1::StavovyRadekClick(TObject *Sender)
{
if(StatusBar->Visible == true) {
        StatusBar->Visible = false;
        StavovyRadek->Checked = false;
        RichEdit1->Height = RichEdit1->Height + 19;
        }
else {
      StatusBar->Visible = true;
      StavovyRadek->Checked = true;
      RichEdit1->Height = RichEdit1->Height - 19;
      StatusBar->Top = 561-19;
     }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::PanelNastrojuClick(TObject *Sender)
{
if(ToolBar1->Visible == true) {
        ToolBar1->Visible = false;
        PanelNastroju->Checked = false;
        }
else {ToolBar1->Visible = true;
      PanelNastroju->Checked = true;
        }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::RadioButton1Click(TObject *Sender)
{
if(RadioButton1->Checked == true){
        Label1->Font->Name = "MS Sans Serif";
        Label2->Font->Name = "MS Sans Serif";

        Label1->Caption = "Y";
        Label2->Caption = "X";
        Label4->Caption = "";
        Label5->Caption = "";

        EditY->Visible = true;
        EditX->Visible = true;

        Edit2->Visible = false;
        Edit3->Visible = false;
        Edit4->Visible = false;
        Edit5->Visible = false;
        Edit6->Visible = false;
        Edit7->Visible = false;
        GroupBox2->Visible = false;
        GroupBox3->Visible = false;
        CheckBox1->Visible = false;

}//if
}
//---------------------------------------------------------------------------

void __fastcall TForm1::RadioButton2Click(TObject *Sender)
{
if(RadioButton2->Checked == true){
        Label1->Font->Name = "Symbol";
        Label2->Font->Name = "Symbol";

        Label1->Caption = "j";
        Label2->Caption = "l";
        Label4->Caption = "ka";
        Label5->Caption = "dlka";

        EditY->Visible = false;
        EditX->Visible = false;

        Edit2->Visible = true;
        Edit3->Visible = true;
        Edit4->Visible = true;
        Edit5->Visible = true;
        Edit6->Visible = true;
        Edit7->Visible = true;
        GroupBox2->Visible = true;
        GroupBox3->Visible = true;
        CheckBox1->Visible = true;

}//if

}
//---------------------------------------------------------------------------

void __fastcall TForm1::ToolButton11Click(TObject *Sender)
{
try {

double Q, y, x, f, l, C, Z, yRam, xRam, fRam, lRam;

if(RadioButton1->Checked == true){ //vstup v JTSK

  y = EditY->Text.ToDouble();
  x = EditX->Text.ToDouble();

if(x < 900000 || x > 1400000 || y < 10000 || y > 950000){
        RichEdit1->SelAttributes->Color = clRed;
        RichEdit1->Lines->Append(String() + "Bod le mimo zem SR");
        RichEdit1->SelAttributes->Color = clBlack;
        Q = 0;
                                                        }//if
else{
double D,M,S;
RichEdit1->SelAttributes->Color = clBlue;
RichEdit1->Lines->Append(String() + "Souadnice v S-JTSK");
RichEdit1->SelAttributes->Color = clBlack;
RichEdit1->Lines->Append(String() + "\tY = " + FormatFloat("000 000.0000", y));
RichEdit1->Lines->Append(String() + "\tX = " + FormatFloat("000 000.0000", x));
RichEdit1->SelAttributes->Color = clBlue;
RichEdit1->Lines->Append(String() + "Zempisn souadnice");
RichEdit1->SelAttributes->Color = clBlack;

JTSK2fl(y,x,f,l);
double l2 = F2G(l);
DMS(f,D,M,S);
RichEdit1->Lines->Append(String() + "\t" + D + " " + M + "\' " + FormatFloat("0.00000", S) + "\" severn ky");
DMS(l2,D,M,S);
RichEdit1->Lines->Append(String() + "\t" + D + " " + M + "\' " + FormatFloat("0.00000", S) + "\" vchodn dlky od Greenwitche");
DMS(l,D,M,S);
RichEdit1->Lines->Append(String() + "\t" + D + " " + M + "\' " + FormatFloat("0.00000", S) + "\" vchodn dlky od Ferra");


l = 180 + l2;//dl se pot s dlkou od Greenwitche

Q = 1;
}//else

}//if JTSK
//********************************************
if(RadioButton2->Checked == true){ //vstup ze zempisnch souadnic


  double D = Edit2->Text.ToDouble();    //ka
  double M = Edit3->Text.ToDouble();
  double S = Edit4->Text.ToDouble();

  f = DMS2(D,M,S);
  if(f == 0) f = 1e-8;

  if(f > 90) {
    TMsgDlgButtons temp_set;
    temp_set<< mbOK;
    String buffer = "Zempisn ka by mla bt v intervalu 0 a 90";
    switch(MessageDlg(buffer, mtCustom,temp_set,0));
             }

  if(RadioButtonJ->Checked == true) f = -f;

  D = Edit5->Text.ToDouble();     //dlka
  M = Edit6->Text.ToDouble();
  S = Edit7->Text.ToDouble();

  l = DMS2(D,M,S);
  if(l == 0) l = 1e-8;

  if(l > 180) {
    TMsgDlgButtons temp_set;
    temp_set<< mbOK;
    String buffer = "Zempisn dlka by mla bt v intervalu 0 a 180";
    switch(MessageDlg(buffer, mtCustom,temp_set,0));
             }

  if(RadioButtonZ->Checked == true) l = -l;

  if(CheckBox1->Checked == false) l = G2F(l);  //pevod na Ferro ()


if(f < 47.6 || f > 51.1 || l < 29.7 || l > 42.4){//if6
        RichEdit1->SelAttributes->Color = clRed;
        RichEdit1->Lines->Append(String() + "Bod le mimo zem SR");
        RichEdit1->SelAttributes->Color = clBlack;
        Q = 0;

                                                }//if6
else{//else1
  fl2JTSK(f,l,y,x);
        RichEdit1->SelAttributes->Color = clBlue;
        RichEdit1->Lines->Append(String() + "Souadnice v S-JTSK");
        RichEdit1->SelAttributes->Color = clBlack;
        RichEdit1->Lines->Append(String() + "\tY = " + FormatFloat("0.0000", y));
        RichEdit1->Lines->Append(String() + "\tX = " + FormatFloat("0.0000", x));
        Q = 1;
    }//else1

RichEdit1->SelAttributes->Color = clBlue;
RichEdit1->Lines->Append(String() + "Zempisn souadnice");
RichEdit1->SelAttributes->Color = clBlack;

if(f > 0){
DMS(f,D,M,S);
RichEdit1->Lines->Append(String() + "\t" + D + " " + M + "\' " + FormatFloat("0.00000", S) + "\" severn ky");
}

else{
DMS(-f,D,M,S);
RichEdit1->Lines->Append(String() + "\t" + D + " " + M + "\' " + FormatFloat("0.00000", S) + "\" jin ky");
f = -f;
}

double l2 = F2G(l);
                 //l = Ferro ()
                 //l2 = Greenwitch ()
if(l2 > 0){
DMS(l2,D,M,S);
RichEdit1->Lines->Append(String() + "\t" + D + " " + M + "\' " + FormatFloat("0.00000", S) + "\" vchodn dlky od Greenwitche");
          }
else {
DMS(-l2,D,M,S);
RichEdit1->Lines->Append(String() + "\t" + D + " " + M + "\' " + FormatFloat("0.00000", S) + "\" zpadn dlky od Greenwitche");
}


if(l > 0){
DMS(l,D,M,S);
RichEdit1->Lines->Append(String() + "\t" + D + " " + M + "\' " + FormatFloat("0.00000", S) + "\" vchodn dlky od Ferra");
          }
else {
DMS(-l,D,M,S);
RichEdit1->Lines->Append(String() + "\t" + D + " " + M + "\' " + FormatFloat("0.00000", S) + "\" zpadn dlky od Ferra");
}

l = 180 + F2G(l); //dle pracuji s Greenwitchem a kvli Gaussovi je 0 na 180


}//if zempisn


CZ(y,C,Z);
if(Z == 0) y += 1e-8;
CZ(x,C,Z);
if(Z == 0) x += 1e-8;



//***************************************************************
//                   Uren mapovho listu
//***************************************************************

if(CheckBoxGauss->Checked == false && CheckBoxSMO5->Checked == false && CheckBoxxL1->Checked == false || RadioButton1->Checked == true && Q == 0){
}
else {
RichEdit1->Lines->Append(String());
RichEdit1->SelAttributes->Color = clBlue;
RichEdit1->Lines->Append(String() + "Klad mapovch list pro:");
RichEdit1->SelAttributes->Color = clBlack;
}


//***************************************************************
//                             Gauss
//***************************************************************

if(CheckBoxGauss->Checked == true){

if(Q == 0 && RadioButton1->Checked == true){}
else {
RichEdit1->SelAttributes->Color = clGreen;
RichEdit1->Lines->Append(String() + "Mezinrodn mapa svta, Gaussovo zobrazen a systm S42");
RichEdit1->SelAttributes->Color = clBlack;


//mapa 1:1'000'000

double sirka = f;
double delka = l;
//ka

  double s1 = sirka / 4.0;
  double s2, s3;

  CZ(s1,s2,s3);

  double sM = s2 + 1;
  double sMd = sirka - s2*4;

  char megon;
  if(sM == 1) megon = 'A';
  else if(sM == 2) megon = 'B';
  else if(sM == 3) megon = 'C';
  else if(sM == 4) megon = 'D';
  else if(sM == 5) megon = 'E';
  else if(sM == 6) megon = 'F';
  else if(sM == 7) megon = 'G';
  else if(sM == 8) megon = 'H';
  else if(sM == 9) megon = 'I';
  else if(sM == 10) megon = 'J';
  else if(sM == 11) megon = 'K';
  else if(sM == 11) megon = 'L';
  else if(sM == 13) megon = 'M';
  else if(sM == 14) megon = 'N';
  else if(sM == 15) megon = 'O';
  else if(sM == 16) megon = 'P';
  else if(sM == 17) megon = 'Q';
  else if(sM == 18) megon = 'R';
  else if(sM == 19) megon = 'S';
  else if(sM == 20) megon = 'T';
  else if(sM == 21) megon = 'U';
  else if(sM == 22) megon = 'V';
  else if(sM == 23) megon = 'Z';

//dlka
  double d1 = delka / 6.0;
  double d2, d3;

  CZ(d1,d2,d3);

  double dM = d2 + 1;
  double dMd = delka - d2*6;

//rm
  AnsiString fR = "ka rmu";
  if(RadioButtonS->Checked == true) fR = "S";
  else fR = "J";

  CZ(f/4.0,C,Z);
  fRam = 4*C;

  AnsiString lR = "dlka rmu";
  if(RadioButtonV->Checked == true) lR = "V (G)";
  else lR = "Z (G)";

  double l3 = l-180;
  if(l3 < 0) l3 = -l3;

  CZ(l3/6.0,C,Z);
  lRam = 6*C;

  RichEdit1->Lines->Append(String() + "\t1:1 000 000\t" + megon + "-" + dM + "\t\t\tka: " + fRam + " 00' 00\"  " + (fRam + 4) + " 00' 00\" " + fR + "\tdlka: " + lRam + " 00' 00\"  " + (lRam + 6) + " 00' 00\" " + lR);

//1:500'000
  char pet;

  if(sMd > 2 && dMd <= 3) pet = 'A';
  else if(sMd > 2 && dMd > 3) pet = 'B';
  else if(sMd <= 2 && dMd <= 3) pet = 'C';
  else if(sMd <= 2 && dMd > 3) pet = 'D';

//rm
  CZ(f/2.0,C,Z);
  fRam = 2*C;

  CZ(l3/3.0,C,Z);
  lRam = 3*C;

  RichEdit1->Lines->Append(String() +  "\t1:500 000\t" + megon + "-" + dM + "-" + pet    + "\t\t\tka: " + fRam + " 00' 00\"  " + (fRam + 2) + " 00' 00\" " + fR + "\tdlka: " + lRam + " 00' 00\"  " + (lRam + 3) + " 00' 00\" " + lR);

//1:200'000
  double v = 4.0/6.0;
  AnsiString dva = "msk slice";

  if(dMd > 0 && dMd <= 1 && sMd > 5*v && sMd <= 6*v) dva = "I";
  else if(dMd > 1 && dMd <= 2 && sMd > 5*v && sMd <= 6*v) dva = "II";
  else if(dMd > 2 && dMd <= 3 && sMd > 5*v && sMd <= 6*v) dva = "III";
  else if(dMd > 3 && dMd <= 4 && sMd > 5*v && sMd <= 6*v) dva = "IV";
  else if(dMd > 4 && dMd <= 5 && sMd > 5*v && sMd <= 6*v) dva = "V";
  else if(dMd > 5 && dMd <= 6 && sMd > 5*v && sMd <= 6*v) dva = "VI";

  else if(dMd > 0 && dMd <= 1 && sMd > 4*v && sMd <= 5*v) dva = "VII";
  else if(dMd > 1 && dMd <= 2 && sMd > 4*v && sMd <= 5*v) dva = "VIII";
  else if(dMd > 2 && dMd <= 3 && sMd > 4*v && sMd <= 5*v) dva = "IX";
  else if(dMd > 3 && dMd <= 4 && sMd > 4*v && sMd <= 5*v) dva = "X";
  else if(dMd > 4 && dMd <= 5 && sMd > 4*v && sMd <= 5*v) dva = "XI";
  else if(dMd > 5 && dMd <= 6 && sMd > 4*v && sMd <= 5*v) dva = "XII";

  else if(dMd > 0 && dMd <= 1 && sMd > 3*v && sMd <= 4*v) dva = "XIII";
  else if(dMd > 1 && dMd <= 2 && sMd > 3*v && sMd <= 4*v) dva = "XIV";
  else if(dMd > 2 && dMd <= 3 && sMd > 3*v && sMd <= 4*v) dva = "XV";
  else if(dMd > 3 && dMd <= 4 && sMd > 3*v && sMd <= 4*v) dva = "XVI";
  else if(dMd > 4 && dMd <= 5 && sMd > 3*v && sMd <= 4*v) dva = "XVII";
  else if(dMd > 5 && dMd <= 6 && sMd > 3*v && sMd <= 4*v) dva = "XVIII";

  else if(dMd > 0 && dMd <= 1 && sMd > 2*v && sMd <= 3*v) dva = "XIX";
  else if(dMd > 1 && dMd <= 2 && sMd > 2*v && sMd <= 3*v) dva = "XX";
  else if(dMd > 2 && dMd <= 3 && sMd > 2*v && sMd <= 3*v) dva = "XXI";
  else if(dMd > 3 && dMd <= 4 && sMd > 2*v && sMd <= 3*v) dva = "XXII";
  else if(dMd > 4 && dMd <= 5 && sMd > 2*v && sMd <= 3*v) dva = "XXIII";
  else if(dMd > 5 && dMd <= 6 && sMd > 2*v && sMd <= 3*v) dva = "XXIV";

  else if(dMd > 0 && dMd <= 1 && sMd > 1*v && sMd <= 2*v) dva = "XXV";
  else if(dMd > 1 && dMd <= 2 && sMd > 1*v && sMd <= 2*v) dva = "XXVI";
  else if(dMd > 2 && dMd <= 3 && sMd > 1*v && sMd <= 2*v) dva = "XXVII";
  else if(dMd > 3 && dMd <= 4 && sMd > 1*v && sMd <= 2*v) dva = "XXVIII";
  else if(dMd > 4 && dMd <= 5 && sMd > 1*v && sMd <= 2*v) dva = "XXIX";
  else if(dMd > 5 && dMd <= 6 && sMd > 1*v && sMd <= 2*v) dva = "XXX";

  else if(dMd > 0 && dMd <= 1 && sMd > 0*v && sMd <= 1*v) dva = "XXXI";
  else if(dMd > 1 && dMd <= 2 && sMd > 0*v && sMd <= 1*v) dva = "XXXII";
  else if(dMd > 2 && dMd <= 3 && sMd > 0*v && sMd <= 1*v) dva = "XXXIII";
  else if(dMd > 3 && dMd <= 4 && sMd > 0*v && sMd <= 1*v) dva = "XXXIV";
  else if(dMd > 4 && dMd <= 5 && sMd > 0*v && sMd <= 1*v) dva = "XXXV";
  else if(dMd > 5 && dMd <= 6 && sMd > 0*v && sMd <= 1*v) dva = "XXXVI";

//rm
  double Df = DMS2(0,40,0);
  CZ(f/Df,C,Z);
  fRam = C * Df;

  double Df1, Df2, Mf1, Mf2, Sf1, Sf2;

  DMS(fRam,Df1,Mf1,Sf1);
  DMS(fRam + Df,Df2,Mf2,Sf2);


  double Dl = DMS2(1,0,0);
  CZ(l3/Dl,C,Z);
  lRam = C * Dl;

  double Dl1, Dl2, Ml1, Ml2, Sl1, Sl2;

  DMS(lRam,Dl1,Ml1,Sl1);
  DMS(lRam + Dl,Dl2,Ml2,Sl2);

  RichEdit1->Lines->Append(String() +  "\t1:200 000\t" + megon + "-" + dM + "-" + dva + "\t\t\tka: " + Df1 + " " + FormatFloat("00",Mf1) + "' " + FormatFloat("00",Sf1) + "\"  " + Df2 + " " + FormatFloat("00",Mf2) + "' " + FormatFloat("00",Sf2) + "\" " + fR + "\tdlka: " + Dl1 + " " + FormatFloat("00",Ml1) + "' " + FormatFloat("00",Sl1) + "\"  " + Dl2 + " " + FormatFloat("00",Ml2) + "' " + FormatFloat("00",Sl2) + "\" " + lR);

  

//1:100 000
  v = 4.0 / 12.0;
  double sto = 0;

  if(dMd > 0 && dMd <= 0.5 && sMd > 11*v && sMd <= 12*v) sto = 1;
  else if(dMd > 0.5 && dMd <= 1 && sMd > 11*v && sMd <= 12*v) sto = 2;
  else if(dMd > 1 && dMd <= 1.5 && sMd > 11*v && sMd <= 12*v) sto = 3;
  else if(dMd > 1.5 && dMd <= 2 && sMd > 11*v && sMd <= 12*v) sto = 4;
  else if(dMd > 2 && dMd <= 2.5 && sMd > 11*v && sMd <= 12*v) sto = 5;
  else if(dMd > 2.5 && dMd <= 3 && sMd > 11*v && sMd <= 12*v) sto = 6;
  else if(dMd > 3 && dMd <= 3.5 && sMd > 11*v && sMd <= 12*v) sto = 7;
  else if(dMd > 3.5 && dMd <= 4 && sMd > 11*v && sMd <= 12*v) sto = 8;
  else if(dMd > 4 && dMd <= 4.5 && sMd > 11*v && sMd <= 12*v) sto = 9;
  else if(dMd > 4.5 && dMd <= 5 && sMd > 11*v && sMd <= 12*v) sto = 10;
  else if(dMd > 5 && dMd <= 5.5 && sMd > 11*v && sMd <= 12*v) sto = 11;
  else if(dMd > 5.5 && dMd <= 6 && sMd > 11*v && sMd <= 12*v) sto = 12;

  else if(dMd > 0 && dMd <= 0.5 && sMd > 10*v && sMd <= 11*v) sto = 13;
  else if(dMd > 0.5 && dMd <= 1 && sMd > 10*v && sMd <= 11*v) sto = 14;
  else if(dMd > 1 && dMd <= 1.5 && sMd > 10*v && sMd <= 11*v) sto = 15;
  else if(dMd > 1.5 && dMd <= 2 && sMd > 10*v && sMd <= 11*v) sto = 16;
  else if(dMd > 2 && dMd <= 2.5 && sMd > 10*v && sMd <= 11*v) sto = 17;
  else if(dMd > 2.5 && dMd <= 3 && sMd > 10*v && sMd <= 11*v) sto = 18;
  else if(dMd > 3 && dMd <= 3.5 && sMd > 10*v && sMd <= 11*v) sto = 19;
  else if(dMd > 3.5 && dMd <= 4 && sMd > 10*v && sMd <= 11*v) sto = 20;
  else if(dMd > 4 && dMd <= 4.5 && sMd > 10*v && sMd <= 11*v) sto = 21;
  else if(dMd > 4.5 && dMd <= 5 && sMd > 10*v && sMd <= 11*v) sto = 22;
  else if(dMd > 5 && dMd <= 5.5 && sMd > 10*v && sMd <= 11*v) sto = 23;
  else if(dMd > 5.5 && dMd <= 6 && sMd > 10*v && sMd <= 11*v) sto = 24;

  else if(dMd > 0 && dMd <= 0.5 && sMd > 9*v && sMd <= 10*v) sto = 25;
  else if(dMd > 0.5 && dMd <= 1 && sMd > 9*v && sMd <= 10*v) sto = 26;
  else if(dMd > 1 && dMd <= 1.5 && sMd > 9*v && sMd <= 10*v) sto = 27;
  else if(dMd > 1.5 && dMd <= 2 && sMd > 9*v && sMd <= 10*v) sto = 28;
  else if(dMd > 2 && dMd <= 2.5 && sMd > 9*v && sMd <= 10*v) sto = 29;
  else if(dMd > 2.5 && dMd <= 3 && sMd > 9*v && sMd <= 10*v) sto = 30;
  else if(dMd > 3 && dMd <= 3.5 && sMd > 9*v && sMd <= 10*v) sto = 31;
  else if(dMd > 3.5 && dMd <= 4 && sMd > 9*v && sMd <= 10*v) sto = 32;
  else if(dMd > 4 && dMd <= 4.5 && sMd > 9*v && sMd <= 10*v) sto = 33;
  else if(dMd > 4.5 && dMd <= 5 && sMd > 9*v && sMd <= 10*v) sto = 34;
  else if(dMd > 5 && dMd <= 5.5 && sMd > 9*v && sMd <= 10*v) sto = 35;
  else if(dMd > 5.5 && dMd <= 6 && sMd > 9*v && sMd <= 10*v) sto = 36;

  else if(dMd > 0 && dMd <= 0.5 && sMd > 8*v && sMd <= 9*v) sto = 37;
  else if(dMd > 0.5 && dMd <= 1 && sMd > 8*v && sMd <= 9*v) sto = 38;
  else if(dMd > 1 && dMd <= 1.5 && sMd > 8*v && sMd <= 9*v) sto = 39;
  else if(dMd > 1.5 && dMd <= 2 && sMd > 8*v && sMd <= 9*v) sto = 40;
  else if(dMd > 2 && dMd <= 2.5 && sMd > 8*v && sMd <= 9*v) sto = 41;
  else if(dMd > 2.5 && dMd <= 3 && sMd > 8*v && sMd <= 9*v) sto = 42;
  else if(dMd > 3 && dMd <= 3.5 && sMd > 8*v && sMd <= 9*v) sto = 43;
  else if(dMd > 3.5 && dMd <= 4 && sMd > 8*v && sMd <= 9*v) sto = 44;
  else if(dMd > 4 && dMd <= 4.5 && sMd > 8*v && sMd <= 9*v) sto = 45;
  else if(dMd > 4.5 && dMd <= 5 && sMd > 8*v && sMd <= 9*v) sto = 46;
  else if(dMd > 5 && dMd <= 5.5 && sMd > 8*v && sMd <= 9*v) sto = 47;
  else if(dMd > 5.5 && dMd <= 6 && sMd > 8*v && sMd <= 9*v) sto = 48;

  else if(dMd > 0 && dMd <= 0.5 && sMd > 7*v && sMd <= 8*v) sto = 49;
  else if(dMd > 0.5 && dMd <= 1 && sMd > 7*v && sMd <= 8*v) sto = 50;
  else if(dMd > 1 && dMd <= 1.5 && sMd > 7*v && sMd <= 8*v) sto = 51;
  else if(dMd > 1.5 && dMd <= 2 && sMd > 7*v && sMd <= 8*v) sto = 52;
  else if(dMd > 2 && dMd <= 2.5 && sMd > 7*v && sMd <= 8*v) sto = 53;
  else if(dMd > 2.5 && dMd <= 3 && sMd > 7*v && sMd <= 8*v) sto = 54;
  else if(dMd > 3 && dMd <= 3.5 && sMd > 7*v && sMd <= 8*v) sto = 55;
  else if(dMd > 3.5 && dMd <= 4 && sMd > 7*v && sMd <= 8*v) sto = 56;
  else if(dMd > 4 && dMd <= 4.5 && sMd > 7*v && sMd <= 8*v) sto = 57;
  else if(dMd > 4.5 && dMd <= 5 && sMd > 7*v && sMd <= 8*v) sto = 58;
  else if(dMd > 5 && dMd <= 5.5 && sMd > 7*v && sMd <= 8*v) sto = 59;
  else if(dMd > 5.5 && dMd <= 6 && sMd > 7*v && sMd <= 8*v) sto = 60;

  else if(dMd > 0 && dMd <= 0.5 && sMd > 6*v && sMd <= 7*v) sto = 61;
  else if(dMd > 0.5 && dMd <= 1 && sMd > 6*v && sMd <= 7*v) sto = 62;
  else if(dMd > 1 && dMd <= 1.5 && sMd > 6*v && sMd <= 7*v) sto = 63;
  else if(dMd > 1.5 && dMd <= 2 && sMd > 6*v && sMd <= 7*v) sto = 64;
  else if(dMd > 2 && dMd <= 2.5 && sMd > 6*v && sMd <= 7*v) sto = 65;
  else if(dMd > 2.5 && dMd <= 3 && sMd > 6*v && sMd <= 7*v) sto = 66;
  else if(dMd > 3 && dMd <= 3.5 && sMd > 6*v && sMd <= 7*v) sto = 67;
  else if(dMd > 3.5 && dMd <= 4 && sMd > 6*v && sMd <= 7*v) sto = 68;
  else if(dMd > 4 && dMd <= 4.5 && sMd > 6*v && sMd <= 7*v) sto = 69;
  else if(dMd > 4.5 && dMd <= 5 && sMd > 6*v && sMd <= 7*v) sto = 70;
  else if(dMd > 5 && dMd <= 5.5 && sMd > 6*v && sMd <= 7*v) sto = 71;
  else if(dMd > 5.5 && dMd <= 6 && sMd > 6*v && sMd <= 7*v) sto = 72;

  else if(dMd > 0 && dMd <= 0.5 && sMd > 5*v && sMd <= 6*v) sto = 73;
  else if(dMd > 0.5 && dMd <= 1 && sMd > 5*v && sMd <= 6*v) sto = 74;
  else if(dMd > 1 && dMd <= 1.5 && sMd > 5*v && sMd <= 6*v) sto = 75;
  else if(dMd > 1.5 && dMd <= 2 && sMd > 5*v && sMd <= 6*v) sto = 76;
  else if(dMd > 2 && dMd <= 2.5 && sMd > 5*v && sMd <= 6*v) sto = 77;
  else if(dMd > 2.5 && dMd <= 3 && sMd > 5*v && sMd <= 6*v) sto = 78;
  else if(dMd > 3 && dMd <= 3.5 && sMd > 5*v && sMd <= 6*v) sto = 79;
  else if(dMd > 3.5 && dMd <= 4 && sMd > 5*v && sMd <= 6*v) sto = 80;
  else if(dMd > 4 && dMd <= 4.5 && sMd > 5*v && sMd <= 6*v) sto = 81;
  else if(dMd > 4.5 && dMd <= 5 && sMd > 5*v && sMd <= 6*v) sto = 82;
  else if(dMd > 5 && dMd <= 5.5 && sMd > 5*v && sMd <= 6*v) sto = 83;
  else if(dMd > 5.5 && dMd <= 5 && sMd > 5*v && sMd <= 6*v) sto = 84;

  else if(dMd > 0 && dMd <= 0.5 && sMd > 4*v && sMd <= 5*v) sto = 85;
  else if(dMd > 0.5 && dMd <= 1 && sMd > 4*v && sMd <= 5*v) sto = 86;
  else if(dMd > 1 && dMd <= 1.5 && sMd > 4*v && sMd <= 5*v) sto = 87;
  else if(dMd > 1.5 && dMd <= 2 && sMd > 4*v && sMd <= 5*v) sto = 88;
  else if(dMd > 2 && dMd <= 2.5 && sMd > 4*v && sMd <= 5*v) sto = 89;
  else if(dMd > 2.5 && dMd <= 3 && sMd > 4*v && sMd <= 5*v) sto = 90;
  else if(dMd > 3 && dMd <= 3.5 && sMd > 4*v && sMd <= 5*v) sto = 91;
  else if(dMd > 3.5 && dMd <= 4 && sMd > 4*v && sMd <= 5*v) sto = 92;
  else if(dMd > 4 && dMd <= 4.5 && sMd > 4*v && sMd <= 5*v) sto = 93;
  else if(dMd > 4.5 && dMd <= 5 && sMd > 4*v && sMd <= 5*v) sto = 94;
  else if(dMd > 5 && dMd <= 5.5 && sMd > 4*v && sMd <= 5*v) sto = 95;
  else if(dMd > 5.5 && dMd <= 4 && sMd > 4*v && sMd <= 5*v) sto = 96;

  else if(dMd > 0 && dMd <= 0.5 && sMd > 3*v && sMd <= 4*v) sto = 97;
  else if(dMd > 0.5 && dMd <= 1 && sMd > 3*v && sMd <= 4*v) sto = 98;
  else if(dMd > 1 && dMd <= 1.5 && sMd > 3*v && sMd <= 4*v) sto = 99;
  else if(dMd > 1.5 && dMd <= 2 && sMd > 3*v && sMd <= 4*v) sto = 100;
  else if(dMd > 2 && dMd <= 2.5 && sMd > 3*v && sMd <= 4*v) sto = 101;
  else if(dMd > 2.5 && dMd <= 3 && sMd > 3*v && sMd <= 4*v) sto = 102;
  else if(dMd > 3 && dMd <= 3.5 && sMd > 3*v && sMd <= 4*v) sto = 103;
  else if(dMd > 3.5 && dMd <= 4 && sMd > 3*v && sMd <= 4*v) sto = 104;
  else if(dMd > 4 && dMd <= 4.5 && sMd > 3*v && sMd <= 4*v) sto = 105;
  else if(dMd > 4.5 && dMd <= 5 && sMd > 3*v && sMd <= 4*v) sto = 106;
  else if(dMd > 5 && dMd <= 5.5 && sMd > 3*v && sMd <= 4*v) sto = 107;
  else if(dMd > 5.5 && dMd <= 3 && sMd > 3*v && sMd <= 4*v) sto = 108;

  else if(dMd > 0 && dMd <= 0.5 && sMd > 2*v && sMd <= 3*v) sto = 109;
  else if(dMd > 0.5 && dMd <= 1 && sMd > 2*v && sMd <= 3*v) sto = 110;
  else if(dMd > 1 && dMd <= 1.5 && sMd > 2*v && sMd <= 3*v) sto = 111;
  else if(dMd > 1.5 && dMd <= 2 && sMd > 2*v && sMd <= 3*v) sto = 112;
  else if(dMd > 2 && dMd <= 2.5 && sMd > 2*v && sMd <= 3*v) sto = 113;
  else if(dMd > 2.5 && dMd <= 3 && sMd > 2*v && sMd <= 3*v) sto = 114;
  else if(dMd > 3 && dMd <= 3.5 && sMd > 2*v && sMd <= 3*v) sto = 115;
  else if(dMd > 3.5 && dMd <= 4 && sMd > 2*v && sMd <= 3*v) sto = 116;
  else if(dMd > 4 && dMd <= 4.5 && sMd > 2*v && sMd <= 3*v) sto = 117;
  else if(dMd > 4.5 && dMd <= 5 && sMd > 2*v && sMd <= 3*v) sto = 118;
  else if(dMd > 5 && dMd <= 5.5 && sMd > 2*v && sMd <= 3*v) sto = 119;
  else if(dMd > 5.5 && dMd <= 2 && sMd > 2*v && sMd <= 3*v) sto = 120;

  else if(dMd > 0 && dMd <= 0.5 && sMd > 1*v && sMd <= 2*v) sto = 121;
  else if(dMd > 0.5 && dMd <= 1 && sMd > 1*v && sMd <= 2*v) sto = 122;
  else if(dMd > 1 && dMd <= 1.5 && sMd > 1*v && sMd <= 2*v) sto = 123;
  else if(dMd > 1.5 && dMd <= 2 && sMd > 1*v && sMd <= 2*v) sto = 124;
  else if(dMd > 2 && dMd <= 2.5 && sMd > 1*v && sMd <= 2*v) sto = 125;
  else if(dMd > 2.5 && dMd <= 3 && sMd > 1*v && sMd <= 2*v) sto = 126;
  else if(dMd > 3 && dMd <= 3.5 && sMd > 1*v && sMd <= 2*v) sto = 127;
  else if(dMd > 3.5 && dMd <= 4 && sMd > 1*v && sMd <= 2*v) sto = 128;
  else if(dMd > 4 && dMd <= 4.5 && sMd > 1*v && sMd <= 2*v) sto = 129;
  else if(dMd > 4.5 && dMd <= 5 && sMd > 1*v && sMd <= 2*v) sto = 130;
  else if(dMd > 5 && dMd <= 5.5 && sMd > 1*v && sMd <= 2*v) sto = 131;
  else if(dMd > 5.5 && dMd <= 1 && sMd > 1*v && sMd <= 2*v) sto = 132;

  else if(dMd > 0 && dMd <= 0.5 && sMd > 0*v && sMd <= 1*v) sto = 133;
  else if(dMd > 0.5 && dMd <= 1 && sMd > 0*v && sMd <= 1*v) sto = 134;
  else if(dMd > 1 && dMd <= 1.5 && sMd > 0*v && sMd <= 1*v) sto = 135;
  else if(dMd > 1.5 && dMd <= 2 && sMd > 0*v && sMd <= 1*v) sto = 136;
  else if(dMd > 2 && dMd <= 2.5 && sMd > 0*v && sMd <= 1*v) sto = 137;
  else if(dMd > 2.5 && dMd <= 3 && sMd > 0*v && sMd <= 1*v) sto = 138;
  else if(dMd > 3 && dMd <= 3.5 && sMd > 0*v && sMd <= 1*v) sto = 139;
  else if(dMd > 3.5 && dMd <= 4 && sMd > 0*v && sMd <= 1*v) sto = 140;
  else if(dMd > 4 && dMd <= 4.5 && sMd > 0*v && sMd <= 1*v) sto = 141;
  else if(dMd > 4.5 && dMd <= 5 && sMd > 0*v && sMd <= 1*v) sto = 142;
  else if(dMd > 5 && dMd <= 5.5 && sMd > 0*v && sMd <= 1*v) sto = 143;
  else if(dMd > 5.5 && dMd <= 0 && sMd > 0*v && sMd <= 1*v) sto = 144;

//rm
  Df = DMS2(0,20,0);
  CZ(f/Df,C,Z);
  fRam = C * Df;

  DMS(fRam,Df1,Mf1,Sf1);
  DMS(fRam + Df,Df2,Mf2,Sf2);


  Dl = DMS2(0,30,0);
  CZ(l3/Dl,C,Z);
  lRam = C * Dl;

  DMS(lRam,Dl1,Ml1,Sl1);
  DMS(lRam + Dl,Dl2,Ml2,Sl2);


  RichEdit1->Lines->Append(String() +  "\t1:100 000\t" + megon + "-" + dM + "-" + sto + "\t\t\tka: " + Df1 + " " + FormatFloat("00",Mf1) + "' " + FormatFloat("00",Sf1) + "\"  " + Df2 + " " + FormatFloat("00",Mf2) + "' " + FormatFloat("00",Sf2) + "\" " + fR + "\tdlka: " + Dl1 + " " + FormatFloat("00",Ml1) + "' " + FormatFloat("00",Sl1) + "\"  " + Dl2 + " " + FormatFloat("00",Ml2) + "' " + FormatFloat("00",Sl2) + "\" " + lR);

//1:50 000
double s;
//ka
  s = 4.0 / 12.0;  // s = 1/3 - ka vrstvy pro 1:50 000
  CZ(sMd/s,C,Z);
  double s100 = sMd - C*s;
  sMd = s100;

//dlka
  double d = 6.0 / 12.0;  //  d = 0.5 - ka sloupce pro 1:50 000
  CZ(dMd/d,C,Z);
  double d100 = dMd - C*d;
  dMd = d100;

  char pad = 'Q';
  if(s100 > s/2.0 && s100 <= s && d100 > 0 && d100 <= d/2.0) pad = 'A';
  else if(s100 > s/2.0 && s100 <= s && d100 > d/2.0 && d100 <= d) pad = 'B';
  else if(s100 > 0 && s100 <= s/2.0 && d100 > 0 && d100 <= d/2.0) pad = 'C';
  else if(s100 > 0 && s100 <= s/2.0 && d100 > d/2 && d100 <= d) pad = 'D';

//rm
  Df = DMS2(0,10,0);
  CZ(f/Df,C,Z);
  fRam = C * Df;

  DMS(fRam,Df1,Mf1,Sf1);
  DMS(fRam + Df,Df2,Mf2,Sf2);


  Dl = DMS2(0,15,0);
  CZ(l3/Dl,C,Z);
  lRam = C * Dl;

  DMS(lRam,Dl1,Ml1,Sl1);
  DMS(lRam + Dl,Dl2,Ml2,Sl2);


  RichEdit1->Lines->Append(String() +  "\t1:50 000\t" + megon + "-" + dM + "-" + sto + "-" + pad + "\t\tka: " + Df1 + " " + FormatFloat("00",Mf1) + "' " + FormatFloat("00",Sf1) + "\"  " + Df2 + " " + FormatFloat("00",Mf2) + "' " + FormatFloat("00",Sf2) + "\" " + fR + "\tdlka: " + Dl1 + " " + FormatFloat("00",Ml1) + "' " + FormatFloat("00",Sl1) + "\"  " + Dl2 + " " + FormatFloat("00",Ml2) + "' " + FormatFloat("00",Sl2) + "\" " + lR);

//1:25 000
  s = s/2.0;
  d = d/2.0;
  if(s100 > s) s100 -= s;
  if(d100 > d) d100 -= d;

  char dvacetpet = 'q';
  if(s100 > s/2.0 && s100 <= s && d100 > 0 && d100 <= d/2.0) dvacetpet = 'a';
  else if(s100 > s/2.0 && s100 <= s && d100 > d/2.0 && d100 <= d) dvacetpet = 'b';
  else if(s100 > 0 && s100 <= s/2.0 && d100 > 0 && d100 <= d/2.0) dvacetpet = 'c';
  else if(s100 > 0 && s100 <= s/2.0 && d100 > d/2 && d100 <= d) dvacetpet = 'd';


//rm
  Df = DMS2(0,5,0);
  CZ(f/Df,C,Z);
  fRam = C * Df;

  DMS(fRam,Df1,Mf1,Sf1);
  DMS(fRam + Df,Df2,Mf2,Sf2);


  Dl = DMS2(0,7,30);
  CZ(l3/Dl,C,Z);
  lRam = C * Dl;

  DMS(lRam,Dl1,Ml1,Sl1);
  DMS(lRam + Dl,Dl2,Ml2,Sl2);




  RichEdit1->Lines->Append(String() +  "\t1:25 000\t" + megon + "-" + dM + "-" + sto + "-" + pad + "-" + dvacetpet + "\t\tka: " + Df1 + " " + FormatFloat("00",Mf1) + "' " + FormatFloat("00",Sf1) + "\"  " + Df2 + " " + FormatFloat("00",Mf2) + "' " + FormatFloat("00",Sf2) + "\" " + fR + "\tdlka: " + Dl1 + " " + FormatFloat("00",Ml1) + "' " + FormatFloat("00",Sl1) + "\"  " + Dl2 + " " + FormatFloat("00",Ml2) + "' " + FormatFloat("00",Sl2) + "\" " + lR);

//1:10 000

  s = s/2.0;
  d = d/2.0;
  if(s100 > s) s100 -= s;
  if(d100 > d) d100 -= d;

  int deset = 101010101;
  if(s100 > s/2.0 && s100 <= s && d100 > 0 && d100 <= d/2.0) deset = 1;
  else if(s100 > s/2.0 && s100 <= s && d100 > d/2.0 && d100 <= d) deset = 2;
  else if(s100 > 0 && s100 <= s/2.0 && d100 > 0 && d100 <= d/2.0) deset = 3;
  else if(s100 > 0 && s100 <= s/2.0 && d100 > d/2 && d100 <= d) deset = 4;

//rm
  Df = DMS2(0,2,30);
  CZ(f/Df,C,Z);
  fRam = C * Df;

  DMS(fRam,Df1,Mf1,Sf1);
  DMS(fRam + Df,Df2,Mf2,Sf2);


  Dl = DMS2(0,3,45);
  CZ(l3/Dl,C,Z);
  lRam = C * Dl;

  DMS(lRam,Dl1,Ml1,Sl1);
  DMS(lRam + Dl,Dl2,Ml2,Sl2);




  RichEdit1->Lines->Append(String() +  "\t1:10 000\t" + megon + "-" + dM + "-" + sto + "-" + pad + "-" + dvacetpet + "-" + deset + "\t\tka: " + Df1 + " " + FormatFloat("00",Mf1) + "' " + FormatFloat("00",Sf1) + "\"  " + Df2 + " " + FormatFloat("00",Mf2) + "' " + FormatFloat("00",Sf2) + "\" " + fR + "\tdlka: " + Dl1 + " " + FormatFloat("00",Ml1) + "' " + FormatFloat("00",Sl1) + "\"  " + Dl2 + " " + FormatFloat("00",Ml2) + "' " + FormatFloat("00",Sl2) + "\" " + lR);

//1:5 000
  s = 1.0 / 48.0;
  d = 1.0 / 32.0;

  int k5 = 111111111;

  if(dMd > 0*d && dMd <= 1*d && sMd > 15*s && sMd <= 16*s) k5 = 1;
  else if(dMd > 1*d && dMd <= 2*d && sMd > 15*s && sMd <= 16*s) k5 = 2;
  else if(dMd > 2*d && dMd <= 3*d && sMd > 15*s && sMd <= 16*s) k5 = 3;
  else if(dMd > 3*d && dMd <= 4*d && sMd > 15*s && sMd <= 16*s) k5 = 4;
  else if(dMd > 4*d && dMd <= 5*d && sMd > 15*s && sMd <= 16*s) k5 = 5;
  else if(dMd > 5*d && dMd <= 6*d && sMd > 15*s && sMd <= 16*s) k5 = 6;
  else if(dMd > 6*d && dMd <= 7*d && sMd > 15*s && sMd <= 16*s) k5 = 7;
  else if(dMd > 7*d && dMd <= 8*d && sMd > 15*s && sMd <= 16*s) k5 = 8;
  else if(dMd > 8*d && dMd <= 9*d && sMd > 15*s && sMd <= 16*s) k5 = 9;
  else if(dMd > 9*d && dMd <= 10*d && sMd > 15*s && sMd <= 16*s) k5 = 10;
  else if(dMd > 10*d && dMd <= 11*d && sMd > 15*s && sMd <= 16*s) k5 = 11;
  else if(dMd > 11*d && dMd <= 12*d && sMd > 15*s && sMd <= 16*s) k5 = 12;
  else if(dMd > 12*d && dMd <= 13*d && sMd > 15*s && sMd <= 16*s) k5 = 13;
  else if(dMd > 13*d && dMd <= 14*d && sMd > 15*s && sMd <= 16*s) k5 = 14;
  else if(dMd > 14*d && dMd <= 15*d && sMd > 15*s && sMd <= 16*s) k5 = 15;
  else if(dMd > 15*d && dMd <= 16*d && sMd > 15*s && sMd <= 16*s) k5 = 16;

  else if(dMd > 0*d && dMd <= 1*d && sMd > 14*s && sMd <= 15*s) k5 = 17;
  else if(dMd > 1*d && dMd <= 2*d && sMd > 14*s && sMd <= 15*s) k5 = 18;
  else if(dMd > 2*d && dMd <= 3*d && sMd > 14*s && sMd <= 15*s) k5 = 19;
  else if(dMd > 3*d && dMd <= 4*d && sMd > 14*s && sMd <= 15*s) k5 = 20;
  else if(dMd > 4*d && dMd <= 5*d && sMd > 14*s && sMd <= 15*s) k5 = 21;
  else if(dMd > 5*d && dMd <= 6*d && sMd > 14*s && sMd <= 15*s) k5 = 22;
  else if(dMd > 6*d && dMd <= 7*d && sMd > 14*s && sMd <= 15*s) k5 = 23;
  else if(dMd > 7*d && dMd <= 8*d && sMd > 14*s && sMd <= 15*s) k5 = 24;
  else if(dMd > 8*d && dMd <= 9*d && sMd > 14*s && sMd <= 15*s) k5 = 25;
  else if(dMd > 9*d && dMd <= 10*d && sMd > 14*s && sMd <= 15*s) k5 = 26;
  else if(dMd > 10*d && dMd <= 11*d && sMd > 14*s && sMd <= 15*s) k5 = 27;
  else if(dMd > 11*d && dMd <= 12*d && sMd > 14*s && sMd <= 15*s) k5 = 28;
  else if(dMd > 12*d && dMd <= 13*d && sMd > 14*s && sMd <= 15*s) k5 = 29;
  else if(dMd > 13*d && dMd <= 14*d && sMd > 14*s && sMd <= 15*s) k5 = 30;
  else if(dMd > 14*d && dMd <= 15*d && sMd > 14*s && sMd <= 15*s) k5 = 31;
  else if(dMd > 15*d && dMd <= 16*d && sMd > 14*s && sMd <= 15*s) k5 = 32;

  else if(dMd > 0*d && dMd <= 1*d && sMd > 13*s && sMd <= 14*s) k5 = 33;
  else if(dMd > 1*d && dMd <= 2*d && sMd > 13*s && sMd <= 14*s) k5 = 34;
  else if(dMd > 2*d && dMd <= 3*d && sMd > 13*s && sMd <= 14*s) k5 = 35;
  else if(dMd > 3*d && dMd <= 4*d && sMd > 13*s && sMd <= 14*s) k5 = 36;
  else if(dMd > 4*d && dMd <= 5*d && sMd > 13*s && sMd <= 14*s) k5 = 37;
  else if(dMd > 5*d && dMd <= 6*d && sMd > 13*s && sMd <= 14*s) k5 = 38;
  else if(dMd > 6*d && dMd <= 7*d && sMd > 13*s && sMd <= 14*s) k5 = 39;
  else if(dMd > 7*d && dMd <= 8*d && sMd > 13*s && sMd <= 14*s) k5 = 40;
  else if(dMd > 8*d && dMd <= 9*d && sMd > 13*s && sMd <= 14*s) k5 = 41;
  else if(dMd > 9*d && dMd <= 10*d && sMd > 13*s && sMd <= 14*s) k5 = 42;
  else if(dMd > 10*d && dMd <= 11*d && sMd > 13*s && sMd <= 14*s) k5 = 43;
  else if(dMd > 11*d && dMd <= 12*d && sMd > 13*s && sMd <= 14*s) k5 = 44;
  else if(dMd > 12*d && dMd <= 13*d && sMd > 13*s && sMd <= 14*s) k5 = 45;
  else if(dMd > 13*d && dMd <= 14*d && sMd > 13*s && sMd <= 14*s) k5 = 46;
  else if(dMd > 14*d && dMd <= 15*d && sMd > 13*s && sMd <= 14*s) k5 = 47;
  else if(dMd > 15*d && dMd <= 16*d && sMd > 13*s && sMd <= 14*s) k5 = 48;

  else if(dMd > 0*d && dMd <= 1*d && sMd > 12*s && sMd <= 13*s) k5 = 49;
  else if(dMd > 1*d && dMd <= 2*d && sMd > 12*s && sMd <= 13*s) k5 = 50;
  else if(dMd > 2*d && dMd <= 3*d && sMd > 12*s && sMd <= 13*s) k5 = 51;
  else if(dMd > 3*d && dMd <= 4*d && sMd > 12*s && sMd <= 13*s) k5 = 52;
  else if(dMd > 4*d && dMd <= 5*d && sMd > 12*s && sMd <= 13*s) k5 = 53;
  else if(dMd > 5*d && dMd <= 6*d && sMd > 12*s && sMd <= 13*s) k5 = 54;
  else if(dMd > 6*d && dMd <= 7*d && sMd > 12*s && sMd <= 13*s) k5 = 55;
  else if(dMd > 7*d && dMd <= 8*d && sMd > 12*s && sMd <= 13*s) k5 = 56;
  else if(dMd > 8*d && dMd <= 9*d && sMd > 12*s && sMd <= 13*s) k5 = 57;
  else if(dMd > 9*d && dMd <= 10*d && sMd > 12*s && sMd <= 13*s) k5 = 58;
  else if(dMd > 10*d && dMd <= 11*d && sMd > 12*s && sMd <= 13*s) k5 = 59;
  else if(dMd > 11*d && dMd <= 12*d && sMd > 12*s && sMd <= 13*s) k5 = 60;
  else if(dMd > 12*d && dMd <= 13*d && sMd > 12*s && sMd <= 13*s) k5 = 61;
  else if(dMd > 13*d && dMd <= 14*d && sMd > 12*s && sMd <= 13*s) k5 = 62;
  else if(dMd > 14*d && dMd <= 15*d && sMd > 12*s && sMd <= 13*s) k5 = 63;
  else if(dMd > 15*d && dMd <= 16*d && sMd > 12*s && sMd <= 13*s) k5 = 64;

  else if(dMd > 0*d && dMd <= 1*d && sMd > 11*s && sMd <= 12*s) k5 = 65;
  else if(dMd > 1*d && dMd <= 2*d && sMd > 11*s && sMd <= 12*s) k5 = 66;
  else if(dMd > 2*d && dMd <= 3*d && sMd > 11*s && sMd <= 12*s) k5 = 67;
  else if(dMd > 3*d && dMd <= 4*d && sMd > 11*s && sMd <= 12*s) k5 = 68;
  else if(dMd > 4*d && dMd <= 5*d && sMd > 11*s && sMd <= 12*s) k5 = 69;
  else if(dMd > 5*d && dMd <= 6*d && sMd > 11*s && sMd <= 12*s) k5 = 70;
  else if(dMd > 6*d && dMd <= 7*d && sMd > 11*s && sMd <= 12*s) k5 = 71;
  else if(dMd > 7*d && dMd <= 8*d && sMd > 11*s && sMd <= 12*s) k5 = 72;
  else if(dMd > 8*d && dMd <= 9*d && sMd > 11*s && sMd <= 12*s) k5 = 73;
  else if(dMd > 9*d && dMd <= 10*d && sMd > 11*s && sMd <= 12*s) k5 = 74;
  else if(dMd > 10*d && dMd <= 11*d && sMd > 11*s && sMd <= 12*s) k5 = 75;
  else if(dMd > 11*d && dMd <= 12*d && sMd > 11*s && sMd <= 12*s) k5 = 76;
  else if(dMd > 12*d && dMd <= 13*d && sMd > 11*s && sMd <= 12*s) k5 = 77;
  else if(dMd > 13*d && dMd <= 14*d && sMd > 11*s && sMd <= 12*s) k5 = 78;
  else if(dMd > 14*d && dMd <= 15*d && sMd > 11*s && sMd <= 12*s) k5 = 79;
  else if(dMd > 15*d && dMd <= 16*d && sMd > 11*s && sMd <= 12*s) k5 = 80;

  else if(dMd > 0*d && dMd <= 1*d && sMd > 10*s && sMd <= 11*s) k5 = 81;
  else if(dMd > 1*d && dMd <= 2*d && sMd > 10*s && sMd <= 11*s) k5 = 82;
  else if(dMd > 2*d && dMd <= 3*d && sMd > 10*s && sMd <= 11*s) k5 = 83;
  else if(dMd > 3*d && dMd <= 4*d && sMd > 10*s && sMd <= 11*s) k5 = 84;
  else if(dMd > 4*d && dMd <= 5*d && sMd > 10*s && sMd <= 11*s) k5 = 85;
  else if(dMd > 5*d && dMd <= 6*d && sMd > 10*s && sMd <= 11*s) k5 = 86;
  else if(dMd > 6*d && dMd <= 7*d && sMd > 10*s && sMd <= 11*s) k5 = 87;
  else if(dMd > 7*d && dMd <= 8*d && sMd > 10*s && sMd <= 11*s) k5 = 88;
  else if(dMd > 8*d && dMd <= 9*d && sMd > 10*s && sMd <= 11*s) k5 = 89;
  else if(dMd > 9*d && dMd <= 10*d && sMd > 10*s && sMd <= 11*s) k5 = 90;
  else if(dMd > 10*d && dMd <= 11*d && sMd > 10*s && sMd <= 11*s) k5 = 91;
  else if(dMd > 11*d && dMd <= 12*d && sMd > 10*s && sMd <= 11*s) k5 = 92;
  else if(dMd > 12*d && dMd <= 13*d && sMd > 10*s && sMd <= 11*s) k5 = 93;
  else if(dMd > 13*d && dMd <= 14*d && sMd > 10*s && sMd <= 11*s) k5 = 94;
  else if(dMd > 14*d && dMd <= 15*d && sMd > 10*s && sMd <= 11*s) k5 = 95;
  else if(dMd > 15*d && dMd <= 16*d && sMd > 10*s && sMd <= 11*s) k5 = 96;

  else if(dMd > 0*d && dMd <= 1*d && sMd > 9*s && sMd <= 10*s) k5 = 97;
  else if(dMd > 1*d && dMd <= 2*d && sMd > 9*s && sMd <= 10*s) k5 = 98;
  else if(dMd > 2*d && dMd <= 3*d && sMd > 9*s && sMd <= 10*s) k5 = 99;
  else if(dMd > 3*d && dMd <= 4*d && sMd > 9*s && sMd <= 10*s) k5 = 100;
  else if(dMd > 4*d && dMd <= 5*d && sMd > 9*s && sMd <= 10*s) k5 = 101;
  else if(dMd > 5*d && dMd <= 6*d && sMd > 9*s && sMd <= 10*s) k5 = 102;
  else if(dMd > 6*d && dMd <= 7*d && sMd > 9*s && sMd <= 10*s) k5 = 103;
  else if(dMd > 7*d && dMd <= 8*d && sMd > 9*s && sMd <= 10*s) k5 = 104;
  else if(dMd > 8*d && dMd <= 9*d && sMd > 9*s && sMd <= 10*s) k5 = 105;
  else if(dMd > 9*d && dMd <= 10*d && sMd > 9*s && sMd <= 10*s) k5 = 106;
  else if(dMd > 10*d && dMd <= 11*d && sMd > 9*s && sMd <= 10*s) k5 = 107;
  else if(dMd > 11*d && dMd <= 12*d && sMd > 9*s && sMd <= 10*s) k5 = 108;
  else if(dMd > 12*d && dMd <= 13*d && sMd > 9*s && sMd <= 10*s) k5 = 109;
  else if(dMd > 13*d && dMd <= 14*d && sMd > 9*s && sMd <= 10*s) k5 = 110;
  else if(dMd > 14*d && dMd <= 15*d && sMd > 9*s && sMd <= 10*s) k5 = 111;
  else if(dMd > 15*d && dMd <= 16*d && sMd > 9*s && sMd <= 10*s) k5 = 112;

  else if(dMd > 0*d && dMd <= 1*d && sMd > 8*s && sMd <= 9*s) k5 = 113;
  else if(dMd > 1*d && dMd <= 2*d && sMd > 8*s && sMd <= 9*s) k5 = 114;
  else if(dMd > 2*d && dMd <= 3*d && sMd > 8*s && sMd <= 9*s) k5 = 115;
  else if(dMd > 3*d && dMd <= 4*d && sMd > 8*s && sMd <= 9*s) k5 = 116;
  else if(dMd > 4*d && dMd <= 5*d && sMd > 8*s && sMd <= 9*s) k5 = 117;
  else if(dMd > 5*d && dMd <= 6*d && sMd > 8*s && sMd <= 9*s) k5 = 118;
  else if(dMd > 6*d && dMd <= 7*d && sMd > 8*s && sMd <= 9*s) k5 = 119;
  else if(dMd > 7*d && dMd <= 8*d && sMd > 8*s && sMd <= 9*s) k5 = 120;
  else if(dMd > 8*d && dMd <= 9*d && sMd > 8*s && sMd <= 9*s) k5 = 121;
  else if(dMd > 9*d && dMd <= 10*d && sMd > 8*s && sMd <= 9*s) k5 = 122;
  else if(dMd > 10*d && dMd <= 11*d && sMd > 8*s && sMd <= 9*s) k5 = 123;
  else if(dMd > 11*d && dMd <= 12*d && sMd > 8*s && sMd <= 9*s) k5 = 124;
  else if(dMd > 12*d && dMd <= 13*d && sMd > 8*s && sMd <= 9*s) k5 = 125;
  else if(dMd > 13*d && dMd <= 14*d && sMd > 8*s && sMd <= 9*s) k5 = 126;
  else if(dMd > 14*d && dMd <= 15*d && sMd > 8*s && sMd <= 9*s) k5 = 127;
  else if(dMd > 15*d && dMd <= 16*d && sMd > 8*s && sMd <= 9*s) k5 = 128;
  
  else if(dMd > 0*d && dMd <= 1*d && sMd > 7*s && sMd <= 8*s) k5 = 129;
  else if(dMd > 1*d && dMd <= 2*d && sMd > 7*s && sMd <= 8*s) k5 = 130;
  else if(dMd > 2*d && dMd <= 3*d && sMd > 7*s && sMd <= 8*s) k5 = 131;
  else if(dMd > 3*d && dMd <= 4*d && sMd > 7*s && sMd <= 8*s) k5 = 132;
  else if(dMd > 4*d && dMd <= 5*d && sMd > 7*s && sMd <= 8*s) k5 = 133;
  else if(dMd > 5*d && dMd <= 6*d && sMd > 7*s && sMd <= 8*s) k5 = 134;
  else if(dMd > 6*d && dMd <= 7*d && sMd > 7*s && sMd <= 8*s) k5 = 135;
  else if(dMd > 7*d && dMd <= 8*d && sMd > 7*s && sMd <= 8*s) k5 = 136;
  else if(dMd > 8*d && dMd <= 9*d && sMd > 7*s && sMd <= 8*s) k5 = 137;
  else if(dMd > 9*d && dMd <= 10*d && sMd > 7*s && sMd <= 8*s) k5 = 138;
  else if(dMd > 10*d && dMd <= 11*d && sMd > 7*s && sMd <= 8*s) k5 = 139;
  else if(dMd > 11*d && dMd <= 12*d && sMd > 7*s && sMd <= 8*s) k5 = 140;
  else if(dMd > 12*d && dMd <= 13*d && sMd > 7*s && sMd <= 8*s) k5 = 141;
  else if(dMd > 13*d && dMd <= 14*d && sMd > 7*s && sMd <= 8*s) k5 = 142;
  else if(dMd > 14*d && dMd <= 15*d && sMd > 7*s && sMd <= 8*s) k5 = 143;
  else if(dMd > 15*d && dMd <= 16*d && sMd > 7*s && sMd <= 8*s) k5 = 144;

  else if(dMd > 0*d && dMd <= 1*d && sMd > 6*s && sMd <= 7*s) k5 = 145;
  else if(dMd > 1*d && dMd <= 2*d && sMd > 6*s && sMd <= 7*s) k5 = 146;
  else if(dMd > 2*d && dMd <= 3*d && sMd > 6*s && sMd <= 7*s) k5 = 147;
  else if(dMd > 3*d && dMd <= 4*d && sMd > 6*s && sMd <= 7*s) k5 = 148;
  else if(dMd > 4*d && dMd <= 5*d && sMd > 6*s && sMd <= 7*s) k5 = 149;
  else if(dMd > 5*d && dMd <= 6*d && sMd > 6*s && sMd <= 7*s) k5 = 150;
  else if(dMd > 6*d && dMd <= 7*d && sMd > 6*s && sMd <= 7*s) k5 = 151;
  else if(dMd > 7*d && dMd <= 8*d && sMd > 6*s && sMd <= 7*s) k5 = 152;
  else if(dMd > 8*d && dMd <= 9*d && sMd > 6*s && sMd <= 7*s) k5 = 153;
  else if(dMd > 9*d && dMd <= 10*d && sMd > 6*s && sMd <= 7*s) k5 = 154;
  else if(dMd > 10*d && dMd <= 11*d && sMd > 6*s && sMd <= 7*s) k5 = 155;
  else if(dMd > 11*d && dMd <= 12*d && sMd > 6*s && sMd <= 7*s) k5 = 156;
  else if(dMd > 12*d && dMd <= 13*d && sMd > 6*s && sMd <= 7*s) k5 = 157;
  else if(dMd > 13*d && dMd <= 14*d && sMd > 6*s && sMd <= 7*s) k5 = 158;
  else if(dMd > 14*d && dMd <= 15*d && sMd > 6*s && sMd <= 7*s) k5 = 159;
  else if(dMd > 15*d && dMd <= 16*d && sMd > 6*s && sMd <= 7*s) k5 = 160;

  else if(dMd > 0*d && dMd <= 1*d && sMd > 5*s && sMd <= 6*s) k5 = 161;
  else if(dMd > 1*d && dMd <= 2*d && sMd > 5*s && sMd <= 6*s) k5 = 162;
  else if(dMd > 2*d && dMd <= 3*d && sMd > 5*s && sMd <= 6*s) k5 = 163;
  else if(dMd > 3*d && dMd <= 4*d && sMd > 5*s && sMd <= 6*s) k5 = 164;
  else if(dMd > 4*d && dMd <= 5*d && sMd > 5*s && sMd <= 6*s) k5 = 165;
  else if(dMd > 5*d && dMd <= 6*d && sMd > 5*s && sMd <= 6*s) k5 = 166;
  else if(dMd > 6*d && dMd <= 7*d && sMd > 5*s && sMd <= 6*s) k5 = 167;
  else if(dMd > 7*d && dMd <= 8*d && sMd > 5*s && sMd <= 6*s) k5 = 168;
  else if(dMd > 8*d && dMd <= 9*d && sMd > 5*s && sMd <= 6*s) k5 = 169;
  else if(dMd > 9*d && dMd <= 10*d && sMd > 5*s && sMd <= 6*s) k5 = 170;
  else if(dMd > 10*d && dMd <= 11*d && sMd > 5*s && sMd <= 6*s) k5 = 171;
  else if(dMd > 11*d && dMd <= 12*d && sMd > 5*s && sMd <= 6*s) k5 = 172;
  else if(dMd > 12*d && dMd <= 13*d && sMd > 5*s && sMd <= 6*s) k5 = 173;
  else if(dMd > 13*d && dMd <= 14*d && sMd > 5*s && sMd <= 6*s) k5 = 174;
  else if(dMd > 14*d && dMd <= 15*d && sMd > 5*s && sMd <= 6*s) k5 = 175;
  else if(dMd > 15*d && dMd <= 16*d && sMd > 5*s && sMd <= 6*s) k5 = 176;

  else if(dMd > 0*d && dMd <= 1*d && sMd > 4*s && sMd <= 5*s) k5 = 177;
  else if(dMd > 1*d && dMd <= 2*d && sMd > 4*s && sMd <= 5*s) k5 = 178;
  else if(dMd > 2*d && dMd <= 3*d && sMd > 4*s && sMd <= 5*s) k5 = 179;
  else if(dMd > 3*d && dMd <= 4*d && sMd > 4*s && sMd <= 5*s) k5 = 180;
  else if(dMd > 4*d && dMd <= 5*d && sMd > 4*s && sMd <= 5*s) k5 = 181;
  else if(dMd > 5*d && dMd <= 6*d && sMd > 4*s && sMd <= 5*s) k5 = 182;
  else if(dMd > 6*d && dMd <= 7*d && sMd > 4*s && sMd <= 5*s) k5 = 183;
  else if(dMd > 7*d && dMd <= 8*d && sMd > 4*s && sMd <= 5*s) k5 = 184;
  else if(dMd > 8*d && dMd <= 9*d && sMd > 4*s && sMd <= 5*s) k5 = 185;
  else if(dMd > 9*d && dMd <= 10*d && sMd > 4*s && sMd <= 5*s) k5 = 186;
  else if(dMd > 10*d && dMd <= 11*d && sMd > 4*s && sMd <= 5*s) k5 = 187;
  else if(dMd > 11*d && dMd <= 12*d && sMd > 4*s && sMd <= 5*s) k5 = 188;
  else if(dMd > 12*d && dMd <= 13*d && sMd > 4*s && sMd <= 5*s) k5 = 189;
  else if(dMd > 13*d && dMd <= 14*d && sMd > 4*s && sMd <= 5*s) k5 = 190;
  else if(dMd > 14*d && dMd <= 15*d && sMd > 4*s && sMd <= 5*s) k5 = 191;
  else if(dMd > 15*d && dMd <= 16*d && sMd > 4*s && sMd <= 5*s) k5 = 192;

  else if(dMd > 0*d && dMd <= 1*d && sMd > 3*s && sMd <= 4*s) k5 = 193;
  else if(dMd > 1*d && dMd <= 2*d && sMd > 3*s && sMd <= 4*s) k5 = 194;
  else if(dMd > 2*d && dMd <= 3*d && sMd > 3*s && sMd <= 4*s) k5 = 195;
  else if(dMd > 3*d && dMd <= 4*d && sMd > 3*s && sMd <= 4*s) k5 = 196;
  else if(dMd > 4*d && dMd <= 5*d && sMd > 3*s && sMd <= 4*s) k5 = 197;
  else if(dMd > 5*d && dMd <= 6*d && sMd > 3*s && sMd <= 4*s) k5 = 198;
  else if(dMd > 6*d && dMd <= 7*d && sMd > 3*s && sMd <= 4*s) k5 = 199;
  else if(dMd > 7*d && dMd <= 8*d && sMd > 3*s && sMd <= 4*s) k5 = 200;
  else if(dMd > 8*d && dMd <= 9*d && sMd > 3*s && sMd <= 4*s) k5 = 201;
  else if(dMd > 9*d && dMd <= 10*d && sMd > 3*s && sMd <= 4*s) k5 = 202;
  else if(dMd > 10*d && dMd <= 11*d && sMd > 3*s && sMd <= 4*s) k5 = 203;
  else if(dMd > 11*d && dMd <= 12*d && sMd > 3*s && sMd <= 4*s) k5 = 204;
  else if(dMd > 12*d && dMd <= 13*d && sMd > 3*s && sMd <= 4*s) k5 = 205;
  else if(dMd > 13*d && dMd <= 14*d && sMd > 3*s && sMd <= 4*s) k5 = 206;
  else if(dMd > 14*d && dMd <= 15*d && sMd > 3*s && sMd <= 4*s) k5 = 207;
  else if(dMd > 15*d && dMd <= 16*d && sMd > 3*s && sMd <= 4*s) k5 = 208;

  else if(dMd > 0*d && dMd <= 1*d && sMd > 2*s && sMd <= 3*s) k5 = 209;
  else if(dMd > 1*d && dMd <= 2*d && sMd > 2*s && sMd <= 3*s) k5 = 210;
  else if(dMd > 2*d && dMd <= 3*d && sMd > 2*s && sMd <= 3*s) k5 = 211;
  else if(dMd > 3*d && dMd <= 4*d && sMd > 2*s && sMd <= 3*s) k5 = 212;
  else if(dMd > 4*d && dMd <= 5*d && sMd > 2*s && sMd <= 3*s) k5 = 213;
  else if(dMd > 5*d && dMd <= 6*d && sMd > 2*s && sMd <= 3*s) k5 = 214;
  else if(dMd > 6*d && dMd <= 7*d && sMd > 2*s && sMd <= 3*s) k5 = 215;
  else if(dMd > 7*d && dMd <= 8*d && sMd > 2*s && sMd <= 3*s) k5 = 216;
  else if(dMd > 8*d && dMd <= 9*d && sMd > 2*s && sMd <= 3*s) k5 = 217;
  else if(dMd > 9*d && dMd <= 10*d && sMd > 2*s && sMd <= 3*s) k5 = 218;
  else if(dMd > 10*d && dMd <= 11*d && sMd > 2*s && sMd <= 3*s) k5 = 219;
  else if(dMd > 11*d && dMd <= 12*d && sMd > 2*s && sMd <= 3*s) k5 = 220;
  else if(dMd > 12*d && dMd <= 13*d && sMd > 2*s && sMd <= 3*s) k5 = 221;
  else if(dMd > 13*d && dMd <= 14*d && sMd > 2*s && sMd <= 3*s) k5 = 222;
  else if(dMd > 14*d && dMd <= 15*d && sMd > 2*s && sMd <= 3*s) k5 = 223;
  else if(dMd > 15*d && dMd <= 16*d && sMd > 2*s && sMd <= 3*s) k5 = 224;

  else if(dMd > 0*d && dMd <= 1*d && sMd > 1*s && sMd <= 2*s) k5 = 225;
  else if(dMd > 1*d && dMd <= 2*d && sMd > 1*s && sMd <= 2*s) k5 = 226;
  else if(dMd > 2*d && dMd <= 3*d && sMd > 1*s && sMd <= 2*s) k5 = 227;
  else if(dMd > 3*d && dMd <= 4*d && sMd > 1*s && sMd <= 2*s) k5 = 228;
  else if(dMd > 4*d && dMd <= 5*d && sMd > 1*s && sMd <= 2*s) k5 = 229;
  else if(dMd > 5*d && dMd <= 6*d && sMd > 1*s && sMd <= 2*s) k5 = 230;
  else if(dMd > 6*d && dMd <= 7*d && sMd > 1*s && sMd <= 2*s) k5 = 231;
  else if(dMd > 7*d && dMd <= 8*d && sMd > 1*s && sMd <= 2*s) k5 = 232;
  else if(dMd > 8*d && dMd <= 9*d && sMd > 1*s && sMd <= 2*s) k5 = 233;
  else if(dMd > 9*d && dMd <= 10*d && sMd > 1*s && sMd <= 2*s) k5 = 234;
  else if(dMd > 10*d && dMd <= 11*d && sMd > 1*s && sMd <= 2*s) k5 = 235;
  else if(dMd > 11*d && dMd <= 12*d && sMd > 1*s && sMd <= 2*s) k5 = 236;
  else if(dMd > 12*d && dMd <= 13*d && sMd > 1*s && sMd <= 2*s) k5 = 237;
  else if(dMd > 13*d && dMd <= 14*d && sMd > 1*s && sMd <= 2*s) k5 = 238;
  else if(dMd > 14*d && dMd <= 15*d && sMd > 1*s && sMd <= 2*s) k5 = 239;
  else if(dMd > 15*d && dMd <= 16*d && sMd > 1*s && sMd <= 2*s) k5 = 240;

  else if(dMd > 0*d && dMd <= 1*d && sMd > 0*s && sMd <= 1*s) k5 = 241;
  else if(dMd > 1*d && dMd <= 2*d && sMd > 0*s && sMd <= 1*s) k5 = 242;
  else if(dMd > 2*d && dMd <= 3*d && sMd > 0*s && sMd <= 1*s) k5 = 243;
  else if(dMd > 3*d && dMd <= 4*d && sMd > 0*s && sMd <= 1*s) k5 = 244;
  else if(dMd > 4*d && dMd <= 5*d && sMd > 0*s && sMd <= 1*s) k5 = 245;
  else if(dMd > 5*d && dMd <= 6*d && sMd > 0*s && sMd <= 1*s) k5 = 246;
  else if(dMd > 6*d && dMd <= 7*d && sMd > 0*s && sMd <= 1*s) k5 = 247;
  else if(dMd > 7*d && dMd <= 8*d && sMd > 0*s && sMd <= 1*s) k5 = 248;
  else if(dMd > 8*d && dMd <= 9*d && sMd > 0*s && sMd <= 1*s) k5 = 249;
  else if(dMd > 9*d && dMd <= 10*d && sMd > 0*s && sMd <= 1*s) k5 = 250;
  else if(dMd > 10*d && dMd <= 11*d && sMd > 0*s && sMd <= 1*s) k5 = 251;
  else if(dMd > 11*d && dMd <= 12*d && sMd > 0*s && sMd <= 1*s) k5 = 252;
  else if(dMd > 12*d && dMd <= 13*d && sMd > 0*s && sMd <= 1*s) k5 = 253;
  else if(dMd > 13*d && dMd <= 14*d && sMd > 0*s && sMd <= 1*s) k5 = 254;
  else if(dMd > 14*d && dMd <= 15*d && sMd > 0*s && sMd <= 1*s) k5 = 255;
  else if(dMd > 15*d && dMd <= 16*d && sMd > 0*s && sMd <= 1*s) k5 = 256;

//rm
  Df = DMS2(0,1,15);
  CZ(f/Df,C,Z);
  fRam = C * Df;

  DMS(fRam,Df1,Mf1,Sf1);
  DMS(fRam + Df,Df2,Mf2,Sf2);

  Dl = DMS2(0,1,52.5);
  CZ(l3/Dl,C,Z);
  lRam = C * Dl;

  DMS(lRam,Dl1,Ml1,Sl1);
  DMS(lRam + Dl,Dl2,Ml2,Sl2);

  RichEdit1->Lines->Append(String() +  "\t1:5 000\t\t" + megon + "-" + dM + "-" + sto + "-(" + k5 + ")"  + "\t\tka: " + Df1 + " " + FormatFloat("00",Mf1) + "' " + FormatFloat("00",Sf1) + "\"  " + Df2 + " " + FormatFloat("00",Mf2) + "' " + FormatFloat("00",Sf2) + "\" " + fR + "\tdlka: " + Dl1 + " " + FormatFloat("00",Ml1) + "' " + FormatFloat("00.0",Sl1) + "\"  " + Dl2 + " " + FormatFloat("00",Ml2) + "' " + FormatFloat("00.0",Sl2) + "\" " + lR);

//1:2 000
//ka
  CZ(sMd/s,C,Z);
  double s5 = sMd - C*s;

//dlka
  CZ(dMd/d,C,Z);
  double d5 = dMd - C*d;

//  s = s/2.0;
//  d = d/2.0;
  if(s5 > s) s5 -= s;
  if(d5 > d) d5 -= d;

  int k2 = 101010101;
  if(s5 > s/2.0 && s5 <= s && d5 > 0 && d5 <= d/2.0) k2 = 1;
  else if(s5 > s/2.0 && s5 <= s && d5 > d/2.0 && d5 <= d) k2 = 2;
  else if(s5 > 0 && s5 <= s/2.0 && d5 > 0 && d5 <= d/2.0) k2 = 3;
  else if(s5 > 0 && s5 <= s/2.0 && d5 > d/2 && d5 <= d) k2 = 4;

//rm
  Df = DMS2(0,0,37.5);
  CZ(f/Df,C,Z);
  fRam = C * Df;

  DMS(fRam,Df1,Mf1,Sf1);
  DMS(fRam + Df,Df2,Mf2,Sf2);


  Dl = DMS2(0,0,56.25);
  CZ(l3/Dl,C,Z);
  lRam = C * Dl;

  DMS(lRam,Dl1,Ml1,Sl1);
  DMS(lRam + Dl,Dl2,Ml2,Sl2);

  RichEdit1->Lines->Append(String() +  "\t1:2 000\t\t" + megon + "-" + dM + "-" + sto + "-(" + k5 + ")-" + k2  + "\t\tka: " + Df1 + " " + FormatFloat("00",Mf1) + "' " + FormatFloat("00.0",Sf1) + "\"  " + Df2 + " " + FormatFloat("00",Mf2) + "' " + FormatFloat("00.0",Sf2) + "\" " + fR + "\tdlka: " + Dl1 + " " + FormatFloat("00",Ml1) + "' " + FormatFloat("00.00",Sl1) + "\"  " + Dl2 + " " + FormatFloat("00",Ml2) + "' " + FormatFloat("00.00",Sl2) + "\" " + lR);

//1:1 000
  s = s/2.0;
  d = d/2.0;
  if(s5 > s) s5 -= s;
  if(d5 > d) d5 -= d;

  int k1 = 101010101;
  if(s5 > s/2.0 && s5 <= s && d5 > 0 && d5 <= d/2.0) k1 = 1;
  else if(s5 > s/2.0 && s5 <= s && d5 > d/2.0 && d5 <= d) k1 = 2;
  else if(s5 > 0 && s5 <= s/2.0 && d5 > 0 && d5 <= d/2.0) k1 = 3;
  else if(s5 > 0 && s5 <= s/2.0 && d5 > d/2 && d5 <= d) k1 = 4;

//rm
  Df = DMS2(0,0,18.75);
  CZ(f/Df,C,Z);
  fRam = C * Df;

  DMS(fRam,Df1,Mf1,Sf1);
  DMS(fRam + Df,Df2,Mf2,Sf2);

  Dl = DMS2(0,0,28.125);
  CZ(l3/Dl,C,Z);
  lRam = C * Dl;

  DMS(lRam,Dl1,Ml1,Sl1);
  DMS(lRam + Dl,Dl2,Ml2,Sl2);

  RichEdit1->Lines->Append(String() +  "\t1:1 000\t\t" + megon + "-" + dM + "-" + sto + "-(" + k5 + ")-" + k2 + k1  + "\t\tka: " + Df1 + " " + FormatFloat("00",Mf1) + "' " + FormatFloat("00.00",Sf1) + "\"  " + Df2 + " " + FormatFloat("00",Mf2) + "' " + FormatFloat("00.00",Sf2) + "\" " + fR + "\tdlka: " + Dl1 + " " + FormatFloat("00",Ml1) + "' " + FormatFloat("00.000",Sl1) + "\"  " + Dl2 + " " + FormatFloat("00",Ml2) + "' " + FormatFloat("00.000",Sl2) + "\" " + lR);

//1:500
  s = s/2.0;
  d = d/2.0;
  if(s5 > s) s5 -= s;
  if(d5 > d) d5 -= d;

  int k05 = 101010101;
  if(s5 > s/2.0 && s5 <= s && d5 > 0 && d5 <= d/2.0) k05 = 1;
  else if(s5 > s/2.0 && s5 <= s && d5 > d/2.0 && d5 <= d) k05 = 2;
  else if(s5 > 0 && s5 <= s/2.0 && d5 > 0 && d5 <= d/2.0) k05 = 3;
  else if(s5 > 0 && s5 <= s/2.0 && d5 > d/2 && d5 <= d) k05 = 4;

//rm
  Df = DMS2(0,0,9.375);
  CZ(f/Df,C,Z);
  fRam = C * Df;

  DMS(fRam,Df1,Mf1,Sf1);
  DMS(fRam + Df,Df2,Mf2,Sf2);

  Dl = DMS2(0,0,14.0625);
  CZ(l3/Dl,C,Z);
  lRam = C * Dl;

  DMS(lRam,Dl1,Ml1,Sl1);
  DMS(lRam + Dl,Dl2,Ml2,Sl2);

  RichEdit1->Lines->Append(String() +  "\t1:500\t\t" + megon + "-" + dM + "-" + sto + "-(" + k5 + ")-" + k2 + k1 + k05  + "\tka: " + Df1 + " " + FormatFloat("00",Mf1) + "' " + FormatFloat("00.000",Sf1) + "\"  " + Df2 + " " + FormatFloat("00",Mf2) + "' " + FormatFloat("00.000",Sf2) + "\" " + fR + "\tdlka: " + Dl1 + " " + FormatFloat("00",Ml1) + "' " + FormatFloat("00.0000",Sl1) + "\"  " + Dl2 + " " + FormatFloat("00",Ml2) + "' " + FormatFloat("00.0000",Sl2) + "\" " + lR);


}//else
}//if Gauss



if(Q ==1){

//***************************************************************
//                             SMO-5
//***************************************************************

if(CheckBoxSMO5->Checked == true){

RichEdit1->SelAttributes->Color = clGreen;
RichEdit1->Lines->Append(String() + "Zkladn mapa velkch mtek, katastrln mapa, SMO5 a SMH5");
RichEdit1->SelAttributes->Color = clBlack;


  AnsiString misto = "Exapolis";
  misto = mesto(y,x);

   double var, q1, q2, y1, x1;

  CZ((y/25000.0),q1,var);
  CZ((x/20000.0),q2,var);

  CZ(q1,y1,var);
  CZ(q2,x1,var);

    double y50k, dy, x50k, dx;

  dy = (y - 25000*y1) / 2500.0;
  dx = (x - 20000*x1) / 2000.0;

  double y5k, yz, x5k, xz;
  CZ(dy,y50k,yz);
  y5k = yz * 2500;

  CZ(dx,x50k,xz);
  x5k = xz * 2000;

//rm
  CZ(y/2500.0,C,Z);
  yRam = C*2500;

  CZ(x/2000.0,C,Z);
  xRam = C*2000;

  RichEdit1->Lines->Append(String() + "\t1:5 000\t\t" + misto + " " + y50k +"-"+ x50k + "\t\ty: " + FormatFloat("000 000.000", yRam) + "  " + FormatFloat("000 000.000",(yRam + 2500)) + "    x: " + FormatFloat("000 000.000", xRam) + "  " + FormatFloat("000 000.000",(xRam + 2000)));

//1:2'000
  double l2k = M_PI;
  if(y5k > 1250 && y5k <= 2500 && x5k > 0 && x5k <= 1000) l2k = 1;
  else if(y5k > 0 && y5k <= 1250 && x5k > 0 && x5k <= 1000) l2k = 2;
  else if(y5k > 1250 && y5k <= 2500 && x5k > 1000 && x5k <= 2000) l2k = 3;
  else if(y5k > 0 && y5k <= 1250 && x5k > 1000 && x5k <= 2000) l2k = 4;

//rm
  CZ(y/1250.0,C,Z);
  yRam = C*1250;

  CZ(x/1000.0,C,Z);
  xRam = C*1000;

  RichEdit1->Lines->Append(String() + "\t1:2 000\t\t" + misto + " " + y50k +"-"+ x50k + "/" + l2k        + "\t\ty: " + FormatFloat("000 000.000", yRam) + "  " + FormatFloat("000 000.000",(yRam + 1250)) + "    x: " + FormatFloat("000 000.000", xRam) + "  " + FormatFloat("000 000.000",(xRam + 1000)));


//1:1'000
  if(y5k > 1250) y5k -= 1250;
  if(x5k > 1000) x5k -= 1000;

  double l1k = M_PI;
  if(y5k > 625 && y5k <= 1250 && x5k > 0 && x5k <= 500) l1k = 1;
  else if(y5k > 0 && y5k <= 625 && x5k > 0 && x5k <= 500) l1k = 2;
  else if(y5k > 625 && y5k <= 1250 && x5k > 500 && x5k <= 1000) l1k = 3;
  else if(y5k > 0 && y5k <= 625 && x5k > 500 && x5k <= 1000) l1k = 4;

//rm
  CZ(y/625.0,C,Z);
  yRam = C*625;

  CZ(x/500.0,C,Z);
  xRam = C*500;

  RichEdit1->Lines->Append(String() + "\t1:1 000\t\t" + misto + " " + y50k +"-"+ x50k + "/" + l2k + l1k  + "\t\ty: " + FormatFloat("000 000.000", yRam) + "  " + FormatFloat("000 000.000",(yRam + 625)) + "    x: " + FormatFloat("000 000.000", xRam) + "  " + FormatFloat("000 000.000",(xRam + 500)));

//1:500
  if(y5k > 625) y5k -= 625;
  if(x5k > 500) x5k -= 500;

  double l500 = M_PI;
  if(y5k > 312.5 && y5k <= 625 && x5k > 0 && x5k <= 250) l500 = 1;
  else if(y5k > 0 && y5k <= 312.5 && x5k > 0 && x5k <= 250) l500 = 2;
  else if(y5k > 312.5 && y5k <= 625 && x5k > 250 && x5k <= 500) l500 = 3;
  else if(y5k > 0 && y5k <= 312.5 && x5k > 250 && x5k <= 500) l500 = 4;

//rm
  CZ(y/312.5,C,Z);
  yRam = C*312.5;

  CZ(x/250.0,C,Z);
  xRam = C*250;

  RichEdit1->Lines->Append(String() + "\t1:500\t\t" + misto + " " + y50k +"-"+ x50k + "/" + l2k + l1k + l500  + "\t\ty: " + FormatFloat("000 000.000", yRam) + "  " + FormatFloat("000 000.000",(yRam + 312.5)) + "    x: " + FormatFloat("000 000.000", xRam) + "  " + FormatFloat("000 000.000",(xRam + 250)));

//1:250
  if(y5k > 312.5) y5k -= 312.5;
  if(x5k > 250) x5k -= 250;

  double l250 = M_PI;
  if(y5k > 156.25 && y5k <= 312.5 && x5k > 0 && x5k <= 125) l250 = 1;
  else if(y5k > 0 && y5k <= 156.25 && x5k > 0 && x5k <= 125) l250 = 2;
  else if(y5k > 156.25 && y5k <= 312.5 && x5k > 125 && x5k <= 250) l250 = 3;
  else if(y5k > 0 && y5k <= 156.25 && x5k > 125 && x5k <= 250) l250 = 4;

//rm  
  CZ(y/156.25,C,Z);
  yRam = C*156.25;

  CZ(x/125.0,C,Z);
  xRam = C*125;

  RichEdit1->Lines->Append(String() + "\t1:250\t\t" + misto + " " + y50k +"-"+ x50k + "/" + l2k + l1k + l500 + l250  + "\ty: " + FormatFloat("000 000.000", yRam) + "  " + FormatFloat("000 000.000",(yRam + 156.25)) + "    x: " + FormatFloat("000 000.000", xRam) + "  " + FormatFloat("000 000.000",(xRam + 125)));

//1:200
  CZ(y/1250.0,C,Z);
  double y200 = (y - C*1250);
  double dy2 = 125;
  double y200L = 999999;

       if(y200 > 0*dy2 && y200 <= 1*dy2) y200L = 0;
  else if(y200 > 1*dy2 && y200 <= 2*dy2) y200L = 1;
  else if(y200 > 2*dy2 && y200 <= 3*dy2) y200L = 2;
  else if(y200 > 3*dy2 && y200 <= 4*dy2) y200L = 3;
  else if(y200 > 4*dy2 && y200 <= 5*dy2) y200L = 4;
  else if(y200 > 5*dy2 && y200 <= 6*dy2) y200L = 5;
  else if(y200 > 6*dy2 && y200 <= 7*dy2) y200L = 6;
  else if(y200 > 7*dy2 && y200 <= 8*dy2) y200L = 7;
  else if(y200 > 8*dy2 && y200 <= 9*dy2) y200L = 8;
  else if(y200 > 9*dy2 && y200 <= 10*dy2) y200L = 9;


  CZ(x/1000.0,C,Z);
  double x200 = (x - C*1000);
  double dx2 = 100;
  double x200L = 999999;

       if(x200 > 0*dx2 && x200 <= 1*dx2) x200L = 0;
  else if(x200 > 1*dx2 && x200 <= 2*dx2) x200L = 1;
  else if(x200 > 2*dx2 && x200 <= 3*dx2) x200L = 2;
  else if(x200 > 3*dx2 && x200 <= 4*dx2) x200L = 3;
  else if(x200 > 4*dx2 && x200 <= 5*dx2) x200L = 4;
  else if(x200 > 5*dx2 && x200 <= 6*dx2) x200L = 5;
  else if(x200 > 6*dx2 && x200 <= 7*dx2) x200L = 6;
  else if(x200 > 7*dx2 && x200 <= 8*dx2) x200L = 7;
  else if(x200 > 8*dx2 && x200 <= 9*dx2) x200L = 8;
  else if(x200 > 9*dx2 && x200 <= 10*dx2) x200L = 9;

//rm
  CZ(y/125.0,C,Z);
  yRam = C*125;

  CZ(x/100.0,C,Z);
  xRam = C*100;

  RichEdit1->Lines->Append(String() + "\t1:200\t\t" + misto + " " + y50k +"-"+ x50k + "/" + l2k + "/" + y200L + "" + x200L + "\ty: " + FormatFloat("000 000.000", yRam) + "  " + FormatFloat("000 000.000",(yRam + 125)) + "    x: " + FormatFloat("000 000.000", xRam) + "  " + FormatFloat("000 000.000",(xRam + 100)));

}//if SMO-5

//***************************************************************
//                    Mapov listy v S-JTSK
//***************************************************************

if(CheckBoxxL1->Checked == true){//if xL v JTSK

RichEdit1->SelAttributes->Color = clGreen;
RichEdit1->Lines->Append(String() + "Mapov listy v S-JTSK");
RichEdit1->SelAttributes->Color = clBlack;

//ZTL 1:100'000
// y
  double y1 = y/50000.0;
  CZ(y1,C,Z);
  double yRa = (C+1)*50;

  AnsiString yR = "Viren Y";
  if(yRa == 50) yR = "L";
  else if(yRa == 100) yR = "C";
  else if(yRa == 150) yR = "CL";
  else if(yRa == 200) yR = "CC";
  else if(yRa == 250) yR = "CCL";
  else if(yRa == 300) yR = "CCC";
  else if(yRa == 350) yR = "CCCL";
  else if(yRa == 400) yR = "CD";
  else if(yRa == 450) yR = "CDL";
  else if(yRa == 500) yR = "D";
  else if(yRa == 550) yR = "DL";
  else if(yRa == 600) yR = "DC";
  else if(yRa == 650) yR = "DCL";
  else if(yRa == 700) yR = "DCC";
  else if(yRa == 750) yR = "DCCL";
  else if(yRa == 800) yR = "DCCC";
  else if(yRa == 850) yR = "DCCCL";
  else if(yRa == 900) yR = "CM";
  else if(yRa == 950) yR = "LM";

// x
  double x1 = x/50000.0;
  CZ(x1,C,Z);
  double xRa = (C+1)*50;

  AnsiString xR = "Viren X";
  if(xRa == 900) xR = "CM";
  else if(xRa == 950) xR = "CML";
  else if(xRa == 1000) xR = "M";
  else if(xRa == 1050) xR = "ML";
  else if(xRa == 1100) xR = "MC";
  else if(xRa == 1150) xR = "MCL";
  else if(xRa == 1200) xR = "MCC";
  else if(xRa == 1250) xR = "MCCL";
  else if(xRa == 1300) xR = "MCCC";
  else if(xRa == 1350) xR = "MCCCL";
  else if(xRa == 1400) xR = "MCD";

  CZ(y/50000.0,C,Z);
  yRam = C*50000;

  CZ(x/50000.0,C,Z);
  xRam = C*50000;

  RichEdit1->Lines->Append(String() + "\tZTL 1:100 000\t" + yR + "-" + xR  + "\t\ty: " + FormatFloat("000 000.000", yRam) + "  " + FormatFloat("000 000.000",(yRam + 50000)) + "    x: " + FormatFloat("000 000.000", xRam) + "  " + FormatFloat("000 000.000",(xRam + 50000)));

//TL 1:20'000
// y
  y1 = y/10000.0;
  CZ(y1,C,Z);
  double yTL = (C+1)*10;

// x
  x1 = x/10000.0;
  CZ(x1,C,Z);
  double xTL = (C+1)*10;

  RichEdit1->Lines->Append(String() + "\tTL 1:20 000\t" + yTL + "-" + xTL + "\t\ty: " + FormatFloat("000 000.000", (1000*yTL - 10000)) + "  " + FormatFloat("000 000.000",(1000*yTL)) + "    x: " + FormatFloat("000 000.000",(1000*xTL - 10000)) + "  " + FormatFloat("000 000.000",(1000*xTL)));

//ML 1:2'000
// y
  y1 = y/1250.0;
  CZ(y1,C,Z);
  double yML2 = (C+1)*1.25;

// x
  x1 = x/1000.0;
  CZ(x1,C,Z);
  double xML2 = (C+1)*1.00;

  RichEdit1->Lines->Append(String() + "\tML 1:2 000\t" + FormatFloat("0.00", yML2) + "-" + FormatFloat("0.00", xML2)  + "\t\ty: " + FormatFloat("000 000.000", (1000*yML2 - 1250)) + "  " + FormatFloat("000 000.000",(1000*yML2)) + "    x: " + FormatFloat("000 000.000",(1000*xML2 - 1000)) + "  " + FormatFloat("000 000.000",(1000*xML2)));

//ML 1:1'000
// y
  y1 = y/625.0;
  CZ(y1,C,Z);
  double yML1 = (C+1)*0.625;

// x
  x1 = x/500.0;
  CZ(x1,C,Z);
  double xML1 = (C+1)*0.5;

  RichEdit1->Lines->Append(String() + "\tML 1:1 000\t" + FormatFloat("0.000", yML1) + "-" + FormatFloat("0.000", xML1)         + "\ty: " + FormatFloat("000 000.000", (1000*yML1 - 625)) + "  " + FormatFloat("000 000.000",(1000*yML1)) + "    x: " + FormatFloat("000 000.000",(1000*xML1 - 500)) + "  " + FormatFloat("000 000.000",(1000*xML1)));

//ML 1:500
// y
  y1 = y/312.5;
  CZ(y1,C,Z);
  double yML05 = (C+1)*0.3125;

//x
  x1 = x/250.0;
  CZ(x1,C,Z);
  double xML05 = (C+1)*0.25;

  RichEdit1->Lines->Append(String() + "\tML 1:500\t" + FormatFloat("0.0000", yML05) + "-" + FormatFloat("0.0000", xML05)         + "\ty: " + FormatFloat("000 000.000", (1000*yML05 - 312.5)) + "  " + FormatFloat("000 000.000",(1000*yML05)) + "    x: " + FormatFloat("000 000.000",(1000*xML05 - 250)) + "  " + FormatFloat("000 000.000",(1000*xML05)));

}//if xL v JTSK


//***************************************************************
//   Nomenklatura enidennch jednotek (triangulanch list)
//***************************************************************

if(CheckBoxN->Checked == true){//if Nomenklatura
RichEdit1->Lines->Append(String());
RichEdit1->SelAttributes->Color = clGreen;
RichEdit1->Lines->Append(String() + "Nomenklatura evidennch jednotek (triangulanch list)");
RichEdit1->SelAttributes->Color = clBlack;

//ZTL
// y
  double y1 = y/50000.0;
  CZ(y1,C,Z);
  double yN = (C+1)*50;
  double yT = y/1000.0 - yN + 50;

// x
  double x1 = x/50000.0;
  CZ(x1,C,Z);
  double xN = (C+1)*50;
  double xT = x/1000.0 - xN + 50;

  int ZTL = 999999;


       if(xN == 950 && yN == 750) ZTL = 1;
  else if(xN == 950 && yN == 700) ZTL = 2;

  else if(xN == 1000 && yN == 950) ZTL = 3;
  else if(xN == 1000 && yN == 900) ZTL = 4;
  else if(xN == 1000 && yN == 850) ZTL = 5;
  else if(xN == 1000 && yN == 800) ZTL = 6;
  else if(xN == 1000 && yN == 750) ZTL = 7;
  else if(xN == 1000 && yN == 700) ZTL = 8;
  else if(xN == 1000 && yN == 650) ZTL = 9;
  else if(xN == 1000 && yN == 600) ZTL = 79;

  else if(xN == 1050 && yN == 950) ZTL = 10;
  else if(xN == 1050 && yN == 900) ZTL = 11;
  else if(xN == 1050 && yN == 850) ZTL = 12;
  else if(xN == 1050 && yN == 800) ZTL = 13;
  else if(xN == 1050 && yN == 750) ZTL = 14;
  else if(xN == 1050 && yN == 700) ZTL = 15;
  else if(xN == 1050 && yN == 650) ZTL = 16;
  else if(xN == 1050 && yN == 600) ZTL = 17;
  else if(xN == 1050 && yN == 550) ZTL = 18;

  else if(xN == 1100 && yN == 900) ZTL = 19;
  else if(xN == 1100 && yN == 850) ZTL = 20;
  else if(xN == 1100 && yN == 800) ZTL = 21;
  else if(xN == 1100 && yN == 750) ZTL = 22;
  else if(xN == 1100 && yN == 700) ZTL = 23;
  else if(xN == 1100 && yN == 650) ZTL = 24;
  else if(xN == 1100 && yN == 600) ZTL = 25;
  else if(xN == 1100 && yN == 550) ZTL = 26;
  else if(xN == 1100 && yN == 500) ZTL = 27;
  else if(xN == 1100 && yN == 450) ZTL = 80;

  else if(xN == 1150 && yN == 900) ZTL = 28;
  else if(xN == 1150 && yN == 850) ZTL = 29;
  else if(xN == 1150 && yN == 800) ZTL = 30;
  else if(xN == 1150 && yN == 750) ZTL = 31;
  else if(xN == 1150 && yN == 700) ZTL = 32;
  else if(xN == 1150 && yN == 650) ZTL = 33;
  else if(xN == 1150 && yN == 600) ZTL = 34;
  else if(xN == 1150 && yN == 550) ZTL = 35;
  else if(xN == 1150 && yN == 500) ZTL = 36;
  else if(xN == 1150 && yN == 450) ZTL = 37;
  else if(xN == 1150 && yN == 400) ZTL = 38;  //SK

  else if(xN == 1200 && yN == 850) ZTL = 39;
  else if(xN == 1200 && yN == 800) ZTL = 40;
  else if(xN == 1200 && yN == 750) ZTL = 41;
  else if(xN == 1200 && yN == 700) ZTL = 42;
  else if(xN == 1200 && yN == 650) ZTL = 43;
  else if(xN == 1200 && yN == 600) ZTL = 44;
  else if(xN == 1200 && yN == 550) ZTL = 45;
  else if(xN == 1200 && yN == 500) ZTL = 46;
  else if(xN == 1200 && yN == 450) ZTL = 47;  //SK ->
  else if(xN == 1200 && yN == 400) ZTL = 48;
  else if(xN == 1200 && yN == 350) ZTL = 48;
  else if(xN == 1200 && yN == 300) ZTL = 50;
  else if(xN == 1200 && yN == 250) ZTL = 51;
  else if(xN == 1200 && yN == 200) ZTL = 52;

  else if(xN == 1250 && yN == 850) ZTL = 81;
  else if(xN == 1250 && yN == 800) ZTL = 53;
  else if(xN == 1250 && yN == 750) ZTL = 54;
  else if(xN == 1250 && yN == 700) ZTL = 82;
  else if(xN == 1250 && yN == 650) ZTL = 55;
  else if(xN == 1250 && yN == 600) ZTL = 56;
  else if(xN == 1250 && yN == 550) ZTL = 57;
  else if(xN == 1250 && yN == 500) ZTL = 58;  //SK ->
  else if(xN == 1250 && yN == 450) ZTL = 59;
  else if(xN == 1250 && yN == 400) ZTL = 60;
  else if(xN == 1250 && yN == 350) ZTL = 61;
  else if(xN == 1250 && yN == 300) ZTL = 62;
  else if(xN == 1250 && yN == 250) ZTL = 63;
  else if(xN == 1250 && yN == 200) ZTL = 64;
// 65 a 78 ???

  int TL = 888888;

       if(xT > 0 && xT <= 10 && yT > 0 && yT <= 10) TL = 1;
  else if(xT > 10 && xT <= 20 && yT > 0 && yT <= 10) TL = 2;
  else if(xT > 20 && xT <= 30 && yT > 0 && yT <= 10) TL = 3;
  else if(xT > 30 && xT <= 40 && yT > 0 && yT <= 10) TL = 4;
  else if(xT > 40 && xT <= 50 && yT > 0 && yT <= 10) TL = 5;

  else if(xT > 0 && xT <= 10 && yT > 10 && yT <= 20) TL = 6;
  else if(xT > 10 && xT <= 20 && yT > 10 && yT <= 20) TL = 7;
  else if(xT > 20 && xT <= 30 && yT > 10 && yT <= 20) TL = 8;
  else if(xT > 30 && xT <= 40 && yT > 10 && yT <= 20) TL = 9;
  else if(xT > 40 && xT <= 50 && yT > 10 && yT <= 20) TL = 10;

  else if(xT > 0 && xT <= 10 && yT > 20 && yT <= 30) TL = 11;
  else if(xT > 10 && xT <= 20 && yT > 20 && yT <= 30) TL = 12;
  else if(xT > 20 && xT <= 30 && yT > 20 && yT <= 30) TL = 13;
  else if(xT > 30 && xT <= 40 && yT > 20 && yT <= 30) TL = 14;
  else if(xT > 40 && xT <= 50 && yT > 20 && yT <= 30) TL = 15;

  else if(xT > 0 && xT <= 10 && yT > 30 && yT <= 40) TL = 16;
  else if(xT > 10 && xT <= 20 && yT > 30 && yT <= 40) TL = 17;
  else if(xT > 20 && xT <= 30 && yT > 30 && yT <= 40) TL = 18;
  else if(xT > 30 && xT <= 40 && yT > 30 && yT <= 40) TL = 19;
  else if(xT > 40 && xT <= 50 && yT > 30 && yT <= 40) TL = 20;

  else if(xT > 0 && xT <= 10 && yT > 40 && yT <= 50) TL = 21;
  else if(xT > 10 && xT <= 20 && yT > 40 && yT <= 50) TL = 22;
  else if(xT > 20 && xT <= 30 && yT > 40 && yT <= 50) TL = 23;
  else if(xT > 30 && xT <= 40 && yT > 40 && yT <= 50) TL = 24;
  else if(xT > 40 && xT <= 50 && yT > 40 && yT <= 50) TL = 25;


  RichEdit1->Lines->Append(String() + "\t\tNomenklatura\t" + FormatFloat("00", ZTL) + FormatFloat("00", TL));

}//if Nomenklatura

}//if Q = 1

}//TRY

catch (EConvertError &E) {
  MessageDlg("patn zadan hodnota: " + E.Message,mtError,TMsgDlgButtons() << mbYes << mbNo,0);
                        }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::UrceniKladu1Click(TObject *Sender)
{
ToolButton11Click(this);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Vypocet1Click(TObject *Sender)
{
//Gauss
if(CheckBoxGauss->Checked == true) Gauss1->Checked = true;
else Gauss1->Checked = false;
//SMO-5
if(CheckBoxSMO5->Checked == true) SMO5->Checked = true;
else SMO5->Checked = false;
//xL v JTSK
if(CheckBoxxL1->Checked == true) xL1->Checked = true;
else xL1->Checked = false;
//Nomenklatura
if(CheckBoxN->Checked == true) Nomenklatura1->Checked = true;
else Nomenklatura1->Checked = false;

}
//---------------------------------------------------------------------------

void __fastcall TForm1::Gauss1Click(TObject *Sender)
{              //Gauss
if(Gauss1->Checked == true) {
Gauss1->Checked = false;
CheckBoxGauss->Checked = false;
        }
else {Gauss1->Checked = true;
CheckBoxGauss->Checked = true;
        }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::SMO5Click(TObject *Sender)
{                  //SMO-5
if(SMO5->Checked == true) {
SMO5->Checked = false;
CheckBoxSMO5->Checked = false;
        }
else {SMO5->Checked = true;
CheckBoxSMO5->Checked = true;
        }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::xL1Click(TObject *Sender)
{             //Mapov listy v S-JTSK
if(xL1->Checked == true) {
xL1->Checked = false;
CheckBoxxL1->Checked = false;
        }
else {xL1->Checked = true;
CheckBoxxL1->Checked = true;
        }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::ToolButton15Click(TObject *Sender)
{
RichEdit1->Lines->Clear();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Vymazat1Click(TObject *Sender)
{
ToolButton15Click(this);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Nomenklatura1Click(TObject *Sender)
{     //Nomenklatura
if(Nomenklatura1->Checked == true) {
Nomenklatura1->Checked = false;
CheckBoxN->Checked = false;
        }
else {Nomenklatura1->Checked = true;
CheckBoxN->Checked = true;
        }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::ToolButton12Click(TObject *Sender)
{
if(RadioButton1->Checked == true) FormCR->Show();
else FormSvet->Show();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Zobrazitnamap1Click(TObject *Sender)
{
ToolButton12Click(this);        
}
//---------------------------------------------------------------------------

void __fastcall TForm1::FormResize(TObject *Sender)
{
  RichEdit1->Height = Form1->Height - (561 - 360 + 1);
  RichEdit1->Width = Form1->Width - (731 - 721 + 1);
}
//---------------------------------------------------------------------------

