//---------------------------------------------------------------------------
#include <vcl.h>
#include <math.h>
#include "rsc_mapove_listy.h"
#include "rsc_math.h"
#include "rsc_geo.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)



void JTSK2fl(double y, double x, double &f, double &l){

//nastaven
double R = 90;      //prav hel (pro prci se stupni 90, v radinech pi/2)
double ro = (2*R)/M_PI;
double S0 = 78.5;
double r0 = 0.9999 * 6380703.6105 * 1/tan(78.5/(180/M_PI));


//Souadnice v S-JTSK
if(y==0) y = 1e-8;
if(x==0) x = 1e-8;

//Polrn souadnice

double r = delka(y,x);
double epsilon = ro*smernik(y,x);

//Kartografick ka a dlka

double D1 = ro * (epsilon/ro) / (sin(S0/ro));    //ka

double S1 = ro * 2 * (atan( (tan((S0/2 + 45)/ro)) / (pow(r/r0,1/( sin(S0/ro)  ))) ) - 45/ro);   //dlka

// Zempisn ka a dlka na referenn kouli
//pl zobrazen:
//Uk = 59 42 42,69690
//Vk = 42 31 31,41725

double Uk = 59.0 + 42.0/60 + 42.69690/3600;   //*
double Vk = 42.0 + 31.0/60 + 31.41725/3600;   //*

double U = ro * asin((sin(S1/ro)) * (sin(Uk/ro)) - (cos(S1/ro)) * (cos(Uk/ro)) * (cos(D1/ro)));

double V = Vk - ro * asin((cos(S1/ro)*sin(D1/ro)) / (cos(U/ro)));

//Zempisn ka na Besselov elipsoidu

double U0 = 49 + 27.0/60.0 + 35.84625/3600; //*
double DU = U - U0;
f = (100.1416022789e-2)*DU - (86.87150417e-6)*DU*DU + (16.70197e-8)*pow(DU,3) + (117.5089e-10)*pow(DU,4) + 49.5;

double a = 1.000597498372;

l = V/a;     //Ferro

//double l2 = l - 17.6665931666667;  //Greenwitch



            /*
//Meridinov konvegence c

double ksi = ro * acos(((cos((90-Uk)/ro)-cos((90-U)/ro)*cos(((90-S1)/ro))))/(sin((90-U)/ro)*sin(((90-S1)/ro))));
double c = epsilon - ksi;
           */

}


void fl2JTSK(double f, double l, double &y, double &x){

//nastaven
double R = 90;      //prav hel (pro prci se stupni 90, v radinech pi/2)
double ro = (2*R)/M_PI;
double S0 = 78.5;
double r0 = 0.9999 * 6380703.6105 * 1/tan(S0/(180/M_PI));
double U0 = 49 + 27.0/60.0 + 35.84625/3600;
double Uk = 59.0 + 42.0/60 + 42.69690/3600;
double Vk = 42.0 + 31.0/60 + 31.41725/3600;
double a = 1.000597498372;  //alfa
double f0 = 49.5;
double n = sin(S0/ro);

//double k = 0.9965924869;
//double e = sqrt(0.0066743722);

//Zempisn ka a dlka na referenn kouli
double Df = f - f0;
double DU = (99.8585979496e-2)*Df + (86.50351075e-6)*Df*Df - (15.10901e-8)*Df*Df*Df - (117.3673e-10)*Df*Df*Df*Df - (180e-14)*Df*Df*Df*Df*Df;
double U = DU + U0;
//double U = (ro*atan(1/k*pow( tan((f/2 + 45)/ro)*pow(   (1-e*sin(f/ro))/(1+e*sin(f/ro))     ,e/2)    ,a)) - 45)*2;

double V = a*l;

//Kartografick ka a dlka
double DV = Vk - V;
double S1 = ro*asin(sin(Uk/ro) * sin(U/ro) + cos(Uk/ro) * cos(U/ro) * cos(DV/ro));

double D1 = ro*asin((sin(DV/ro) * cos(U/ro))/cos(S1/ro));

//Polrn souadnice

double r = r0*(pow(((tan((S0/2 + 45)/ro))/(tan((S1/2 + 45)/ro))),n));
double epsilon = n*D1;

//Souadnice v S-JTSK

y = r * sin(epsilon/ro);
x = r * cos(epsilon/ro);

}








//pevod nulovho polednku F -> G
//dlka je v  intervalu -180 a 180 (zpadn a vchodn dlka)
double F2G(double F){
        double G = F - 17.6665931666667;

        if(G < -180) G += 360;

        return G;
                    }

//pevod nulovho polednku G -> F
//dlka je v  intervalu -180 a 180 (zpadn a vchodn dlka)
double G2F(double G){
        double F = G + 17.6665931666667;

        if(F > 180) F -= 360;

        return F;
                    }



//urn msta pro mapu SMO-5
AnsiString mesto(double y, double x)
  {
  AnsiString mesto = "Bod nen na zem R";

  double var, q1, q2;

  CZ((y/25000.0),q1,var);
  CZ((x/20000.0),q2,var);
  y = 25000*q1;
  x = 20000*q2;

if(x == 920000 && y == 725000) mesto = "Lobendava";
else if(x == 920000 && y == 700000) mesto = "Fukov";
else if(x == 940000 && y == 750000) mesto = "Rjec";
else if(x == 940000 && y == 725000) mesto = "luknov";
else if(x == 940000 && y == 700000) mesto = "Varnsdorf";
else if(x == 940000 && y == 675000) mesto = "Frdlant";
else if(x == 940000 && y == 650000) mesto = "Nov Msto pod Smrkem";
else if(x == 960000 && y == 800000) mesto = "Hora Sv. Kateiny";
else if(x == 960000 && y == 775000) mesto = "Teplice";
else if(x == 960000 && y == 750000) mesto = "st nad Labem";
else if(x == 960000 && y == 725000) mesto = "Dn";
else if(x == 960000 && y == 700000) mesto = "Nov Bor";
else if(x == 960000 && y == 675000) mesto = "Liberec";
else if(x == 960000 && y == 650000) mesto = "Tanvald";
else if(x == 960000 && y == 625000) mesto = "Pta Kmen";
else if(x == 980000 && y == 900000) mesto = "Pastviny";
else if(x == 980000 && y == 875000) mesto = "Hranice v echch";
else if(x == 980000 && y == 850000) mesto = "Kraslice";
else if(x == 980000 && y == 825000) mesto = "Jchymov";
else if(x == 980000 && y == 800000) mesto = "Chomutov";
else if(x == 980000 && y == 775000) mesto = "Most";
else if(x == 980000 && y == 750000) mesto = "Litomice";
else if(x == 980000 && y == 725000) mesto = "Dub";
else if(x == 980000 && y == 700000) mesto = "Mimo";
else if(x == 980000 && y == 675000) mesto = "Turnov";
else if(x == 980000 && y == 650000) mesto = "Vrchlab";
else if(x == 980000 && y == 625000) mesto = "acl";
else if(x == 980000 && y == 600000) mesto = "Mezimst";
else if(x == 980000 && y == 575000) mesto = "Janovice";
else if(x == 1000000 && y == 900000) mesto = "ttary";
else if(x == 1000000 && y == 875000) mesto = "A";
else if(x == 1000000 && y == 850000) mesto = "Sokolov";
else if(x == 1000000 && y == 825000) mesto = "Karlovy Vary";
else if(x == 1000000 && y == 800000) mesto = "atec";
else if(x == 1000000 && y == 775000) mesto = "Louny";
else if(x == 1000000 && y == 750000) mesto = "Libochovice";
else if(x == 1000000 && y == 725000) mesto = "Mlnk";
else if(x == 1000000 && y == 700000) mesto = "Mlad Boleslav";
else if(x == 1000000 && y == 675000) mesto = "Sobotka";
else if(x == 1000000 && y == 650000) mesto = "Jin";
else if(x == 1000000 && y == 625000) mesto = "Trutnov";
else if(x == 1000000 && y == 600000) mesto = "Broumov";
else if(x == 1000000 && y == 575000) mesto = "onov";
else if(x == 1020000 && y == 875000) mesto = "Cheb";
else if(x == 1020000 && y == 850000) mesto = "Marinsk Lzn";
else if(x == 1020000 && y == 825000) mesto = "lutice";
else if(x == 1020000 && y == 800000) mesto = "Jesenice";
else if(x == 1020000 && y == 775000) mesto = "Rakovnk";
else if(x == 1020000 && y == 750000) mesto = "Kladno";
else if(x == 1020000 && y == 725000) mesto = "Kralupy nad Vltavou";
else if(x == 1020000 && y == 700000) mesto = "Brands nad Labem";
else if(x == 1020000 && y == 675000) mesto = "Nymburk";
else if(x == 1020000 && y == 650000) mesto = "Hoice";
else if(x == 1020000 && y == 625000) mesto = "Jarom";
else if(x == 1020000 && y == 600000) mesto = "Nchod";
else if(x == 1020000 && y == 575000) mesto = "Kuntt";
else if(x == 1020000 && y == 550000) mesto = "Javornk";
else if(x == 1020000 && y == 525000) mesto = "Vidnava";
else if(x == 1040000 && y == 875000) mesto = "Ctibo";
else if(x == 1040000 && y == 850000) mesto = "Tachov";
else if(x == 1040000 && y == 825000) mesto = "Mantn";
else if(x == 1040000 && y == 800000) mesto = "Kralovice";
else if(x == 1040000 && y == 775000) mesto = "Kivoklt";
else if(x == 1040000 && y == 750000) mesto = "Beroun";
else if(x == 1040000 && y == 725000) mesto = "Praha";
else if(x == 1040000 && y == 700000) mesto = "esk Brod";
else if(x == 1040000 && y == 675000) mesto = "Koln";
else if(x == 1040000 && y == 650000) mesto = "Pelou";
else if(x == 1040000 && y == 625000) mesto = "Hradec Krlov";
else if(x == 1040000 && y == 600000) mesto = "Rychnov nad Knnou";
else if(x == 1040000 && y == 575000) mesto = "Rokytnice V Orl. Horch";
else if(x == 1040000 && y == 550000) mesto = "Star Msto";
else if(x == 1040000 && y == 525000) mesto = "Jesenk";
else if(x == 1040000 && y == 500000) mesto = "Jindichov";
else if(x == 1060000 && y == 875000) mesto = "Svat Kateina";
else if(x == 1060000 && y == 850000) mesto = "Pimda";
else if(x == 1060000 && y == 825000) mesto = "Stbro";
else if(x == 1060000 && y == 800000) mesto = "Plze";
else if(x == 1060000 && y == 775000) mesto = "Hoovice";
else if(x == 1060000 && y == 750000) mesto = "Dob";
else if(x == 1060000 && y == 725000) mesto = "Beneov";
else if(x == 1060000 && y == 700000) mesto = "Uhlsk Janovice";
else if(x == 1060000 && y == 675000) mesto = "Kutn Hora";
else if(x == 1060000 && y == 650000) mesto = "Hemanv Mstec";
else if(x == 1060000 && y == 625000) mesto = "Pardubice";
else if(x == 1060000 && y == 600000) mesto = "st nad Orlic";
else if(x == 1060000 && y == 575000) mesto = "amberk";
else if(x == 1060000 && y == 550000) mesto = "umperk";
else if(x == 1060000 && y == 525000) mesto = "Bruntl";
else if(x == 1060000 && y == 500000) mesto = "Krnov";
else if(x == 1060000 && y == 475000) mesto = "Sudice";
else if(x == 1080000 && y == 875000) mesto = "Rybnk";
else if(x == 1080000 && y == 850000) mesto = "Domalice";
else if(x == 1080000 && y == 825000) mesto = "Petice";
else if(x == 1080000 && y == 800000) mesto = "Blovice";
else if(x == 1080000 && y == 775000) mesto = "Pbram";
else if(x == 1080000 && y == 750000) mesto = "Krsn Hora";
else if(x == 1080000 && y == 725000) mesto = "Sedlany";
else if(x == 1080000 && y == 700000) mesto = "Vlaim";
else if(x == 1080000 && y == 675000) mesto = "Lede nad Szavou";
else if(x == 1080000 && y == 650000) mesto = "Chotbo";
else if(x == 1080000 && y == 625000) mesto = "Hlinsko";
else if(x == 1080000 && y == 600000) mesto = "Litomyl";
else if(x == 1080000 && y == 575000) mesto = "Moravsk Tebov";
else if(x == 1080000 && y == 550000) mesto = "Zbeh";
else if(x == 1080000 && y == 525000) mesto = "Rmaov";
else if(x == 1080000 && y == 500000) mesto = "Horn Beneov";
else if(x == 1080000 && y == 475000) mesto = "Opava";
else if(x == 1080000 && y == 450000) mesto = "Bohumn";
else if(x == 1080000 && y == 425000) mesto = "Doln Marklovice";
else if(x == 1100000 && y == 850000) mesto = "Kdyn";
else if(x == 1100000 && y == 825000) mesto = "Klatovy";
else if(x == 1100000 && y == 800000) mesto = "Nepomuk";
else if(x == 1100000 && y == 775000) mesto = "Blatn";
else if(x == 1100000 && y == 750000) mesto = "Milevsko";
else if(x == 1100000 && y == 725000) mesto = "Tbor";
else if(x == 1100000 && y == 700000) mesto = "Pacov";
else if(x == 1100000 && y == 675000) mesto = "Humpolec";
else if(x == 1100000 && y == 650000) mesto = "Havlkv Brod";
else if(x == 1100000 && y == 625000) mesto = "Nov Msto na Morav";
else if(x == 1100000 && y == 600000) mesto = "Polika";
else if(x == 1100000 && y == 575000) mesto = "Jevko";
else if(x == 1100000 && y == 550000) mesto = "Litovel";
else if(x == 1100000 && y == 525000) mesto = "ternberk";
else if(x == 1100000 && y == 500000) mesto = "Odry";
else if(x == 1100000 && y == 475000) mesto = "Blovec";
else if(x == 1100000 && y == 450000) mesto = "Ostrava";
else if(x == 1100000 && y == 425000) mesto = "esk Tn";
else if(x == 1120000 && y == 850000) mesto = "Zadn Chalupy";
else if(x == 1120000 && y == 825000) mesto = "Hartmanice";
else if(x == 1120000 && y == 800000) mesto = "Suice";
else if(x == 1120000 && y == 775000) mesto = "Strakonice";
else if(x == 1120000 && y == 750000) mesto = "Psek";
else if(x == 1120000 && y == 725000) mesto = "Sobslav";
else if(x == 1120000 && y == 700000) mesto = "Kamenice nad Lipou";
else if(x == 1120000 && y == 675000) mesto = "Pelhimov";
else if(x == 1120000 && y == 650000) mesto = "Jihlava";
else if(x == 1120000 && y == 625000) mesto = "Velk Mezi";
else if(x == 1120000 && y == 600000) mesto = "Bystice nad Pertejnem";
else if(x == 1120000 && y == 575000) mesto = "Boskovice";
else if(x == 1120000 && y == 550000) mesto = "Prostjov";
else if(x == 1120000 && y == 525000) mesto = "Olomouc";
else if(x == 1120000 && y == 500000) mesto = "Hranice na Morav";
else if(x == 1120000 && y == 475000) mesto = "Nov Jin";
else if(x == 1120000 && y == 450000) mesto = "Frdlant nad Ostravic";
else if(x == 1120000 && y == 425000) mesto = "Jablunkov";
else if(x == 1140000 && y == 825000) mesto = "Srn";
else if(x == 1140000 && y == 800000) mesto = "Vimperk";
else if(x == 1140000 && y == 775000) mesto = "Prachatice";
else if(x == 1140000 && y == 750000) mesto = "Hlubok nad Vltavou";
else if(x == 1140000 && y == 725000) mesto = "Vesel nad Lunic";
else if(x == 1140000 && y == 700000) mesto = "Jindichv Hradec";
else if(x == 1140000 && y == 675000) mesto = "Te";
else if(x == 1140000 && y == 650000) mesto = "Teb";
else if(x == 1140000 && y == 625000) mesto = "Nm욝 nad Oslavou";
else if(x == 1140000 && y == 600000) mesto = "Tinov";
else if(x == 1140000 && y == 575000) mesto = "Blansko";
else if(x == 1140000 && y == 550000) mesto = "Vykov";
else if(x == 1140000 && y == 525000) mesto = "Krom";
else if(x == 1140000 && y == 500000) mesto = "Bystice pod Hostnem";
else if(x == 1140000 && y == 475000) mesto = "Vsetn";
else if(x == 1140000 && y == 450000) mesto = "Makov";
else if(x == 1140000 && y == 425000) mesto = "adca";
else if(x == 1160000 && y == 800000) mesto = "Horn Vltavice";
else if(x == 1160000 && y == 775000) mesto = "Volary";
else if(x == 1160000 && y == 750000) mesto = "esk Budjovice";
else if(x == 1160000 && y == 725000) mesto = "Tebo";
else if(x == 1160000 && y == 700000) mesto = "Nov Bystice";
else if(x == 1160000 && y == 675000) mesto = "Daice";
else if(x == 1160000 && y == 650000) mesto = "Moravsk Budjovice";
else if(x == 1160000 && y == 625000) mesto = "Hrotovice";
else if(x == 1160000 && y == 600000) mesto = "Moravsk Krumlov";
else if(x == 1160000 && y == 575000) mesto = "Brno";
else if(x == 1160000 && y == 550000) mesto = "Buovice";
else if(x == 1160000 && y == 525000) mesto = "Napajedla";
else if(x == 1160000 && y == 500000) mesto = "Zln";
else if(x == 1160000 && y == 475000) mesto = "Valask Klobouky";
else if(x == 1160000 && y == 450000) mesto = "Byta";
else if(x == 1180000 && y == 800000) mesto = "Plech";
else if(x == 1180000 && y == 775000) mesto = "Horn Plan";
else if(x == 1180000 && y == 750000) mesto = "esk Krumlov";
else if(x == 1180000 && y == 725000) mesto = "Trhov Sviny";
else if(x == 1180000 && y == 700000) mesto = "esk Velenice";
else if(x == 1180000 && y == 675000) mesto = "Vratnn";
else if(x == 1180000 && y == 650000) mesto = "Vranov";
else if(x == 1180000 && y == 625000) mesto = "Znojmo";
else if(x == 1180000 && y == 600000) mesto = "Pohoelice";
else if(x == 1180000 && y == 575000) mesto = "Hustopee";
else if(x == 1180000 && y == 550000) mesto = "Kyjov";
else if(x == 1180000 && y == 525000) mesto = "Uhersk Hradit";
else if(x == 1180000 && y == 500000) mesto = "Uhersk Brod";
else if(x == 1180000 && y == 475000) mesto = "Ilava";
else if(x == 1200000 && y == 775000) mesto = "Pedn Vto";
else if(x == 1200000 && y == 750000) mesto = "Vy Brod";
else if(x == 1200000 && y == 725000) mesto = "Poho na umav";
else if(x == 1200000 && y == 625000) mesto = "Jaroslavice";
else if(x == 1200000 && y == 600000) mesto = "Mikulov";
else if(x == 1200000 && y == 575000) mesto = "Beclav";
else if(x == 1200000 && y == 550000) mesto = "Hodonn";
else if(x == 1200000 && y == 525000) mesto = "Myjava";
else if(x == 1200000 && y == 500000) mesto = "Nov Msto nad Vhom";
else if(x == 1220000 && y == 575000) mesto = "Moravsk Jn";

        return mesto;
  }
                    
